#!/bin/bash


if [[ $1 ]]; then
    cmdopt=$1
    cmdopt=${cmdopt:0:3}
    cmdopt=${cmdopt,,}
fi

case $cmdopt in
dev)	wxdevelopment=1; export wxdevelopment
    ;;
fup)	wxfupdate=1; export wxfupdate
    ;;
sup)	wxsupdate=1; export wxsupdate
    ;;
deb)	debug=1; export debug
        wxdevelopment=1; export wxdevelopment
    ;;
?)		echo "dev, fup, sup, deb"
        exit 0
    ;;
esac

# -----------------------------------------------------------------------
# stop existing conky processes
# -----------------------------------------------------------------------
if [[ "$(pidof conky)" ]] ; then killall conky; fi

if [[ -s /usr/share/conkywx/conkywx.sh ]]; then
	conkywxVersion=$(/usr/share/conkywx/conkywx.sh -v)
	conkywxVersion="${conkywxVersion//[.]/}"
	WX_DIR="${HOME}/.config/conkywx/examples${conkywxVersion}"
	cd /usr/share/conkywx
else
	WX_DIR="./examples"
fi

# -----------------------------------------------------------------------
# run conky instances
# -----------------------------------------------------------------------

    # conky -c "$WX_DIR/conky-musicrc" &

    # conky -c "$WX_DIR/vertical-scroller-gdacs-conkyrc" &
    # conky -c "$WX_DIR/vertical-scroller-news-conkyrc" &

    # conky -c "$WX_DIR/conkywx-clockrc" &

    conky -c "$WX_DIR/conkywx-weather-rings-systemrc" &
    # conky -c "$WX_DIR/conky-systemrc" &

    conky -c "$WX_DIR/conkywx-surface-imagerc" &
    conky -c "$WX_DIR/seismicrc" &

    # conky -c "$WX_DIR/vertical-scroller-seismic-conkyrc" &
    # conky -c "$WX_DIR/vertical-scroller-weather-conkyrc" &


    conky -c "$WX_DIR/big-luamix-gauge-conkyrc" &
    # conky -c "$WX_DIR/big-luamix-conkyrc" &
    # conky -c "$WX_DIR/flip-big-luamix-conkyrc" &
    # conky -c "$WX_DIR/flip-conkyrc" &
    # conky -c "$WX_DIR/expanded-conkyrc" &
    # conky -c "$WX_DIR/short-conkyrc" &
    # conky -c "$WX_DIR/hartley-conkyrc" &
    # conky -c "$WX_DIR/now-conkyrc" &
    # conky -c "$WX_DIR/slim-conkyrc" &

    # conky -c "$WX_DIR/vertical-scroller-vindsl-weather-conkyrc" &
    # conky -c "$WX_DIR/horizontal-scroller-weather-conkyrc" &

    # conky -c "$WX_DIR/vindsl-org-conkyrc" &


exit 0
