# alignment bottom_right
alignment br
# background yes
cpu_avg_samples 3
net_avg_samples 3

default_color white
default_outline_color black
default_shade_color black
double_buffer yes

draw_borders no
draw_graph_borders no
draw_outline no
draw_shades no

gap_x 0
# gap_y -135
gap_y -132
# gap_y 0

maximum_width 300
minimum_size 280 5

no_buffers yes
override_utf8_locale yes

own_window yes
own_window_type normal
own_window_type normal
own_window_hints below,sticky,undecorated,skip_taskbar,skip_pager
# own_window_colour black
own_window_transparent yes
own_window_class Conky

# ARGB can be used for real transparency,
# note that a composite manager is required for real transparency
# own_window_argb_visual true

# Set the transparency alpha value from 0 to 255
# own_window_argb_value 250


# text_buffer_size 256
text_buffer_size 5000
total_run_times 0
update_interval 5
uppercase no
use_spacer right


use_xft yes
xftalpha 0.8
xftfont DejaVu Sans Mono:size=12
# xftfont DroidSansFallback:size=9

color1 Tan1
color2 DimGray
color3 White
color4 DarkSlateGray
color5 LightGray
color6 yellow
color7 darkgrey

short_units yes

lua_load /usr/share/conkywx/lib/conkywx.lua
# lua_draw_hook_pre main -n music_sort

# red ff0029 tan f85c01
# ltgreen 2fff00 drkgreen 177b00
# ltcyan  00fff3 drkcyan  006964 00a39c
template0 ./conkywx.sh
# template1 "\"$WX_DIR/lib/music_sorter.sh\""

# template9 /sys/devices/platform/coretemp.0/hwmon/hwmon0/
template9 /sys/class/hwmon/hwmon0/
template8 /sys/devices/platform/w83627ehf.656/temp4_input
template7 /sys/devices/platform/w83627ehf.656/fan2_input

TEXT
# ${voffset -9}${lua main -n background -r 45 -c 0x000000:0.5 -s NA,NA }
${voffset -9}${lua main -n background -r 45 -c 0x555555:0.5 -s NA,NA }
${font  Mono:size=9}${execpi 60 my_cal=$(date +%-d); cal | \
sed 's/\<'$my_cal'\>/${color1}&${color3}/g'}
${voffset -115}  ${font Arial:bold:size=18}$alignr${color3}Arch${font Arial:bold:size=18}$alignr${color1}LINUX
${voffset 0}${font Arial:bold:size=36}${color5}$alignr ${time %H:%M}${font}${color5}${font}
${voffset 0}${font Arial:bold:size=16}${color3}$alignr${time %a}${font Arial:bold:size=16}${color1}$alignr ${time %d}${font Arial:bold:size=16}${color3}$alignr ${time %Y}
# --------------------------------------------------------------------
# world time - present time in diff cities
# --------------------------------------------------------------------
${voffset 14}${font :bold:size=10}${color1}WORLD TIME ${color4}${hr 2}${font}${color3}
${color3}UTC:${goto 36}${color1}${tztime UTC %d-%H:%M}${goto 100}${color3}BKK:${goto 133}${color1}${tztime Asia/Bangkok %d-%H:%M}${goto 198}${color3}TKO:${goto 230}${color1}${tztime Asia/Tokyo  %d-%H:%M}
${color3}LAX:${goto 36}${color1}${tztime America/Los_Angeles %d-%H:%M}${goto 100}${color3}HOU:${goto 133}${color1}${tztime America/Mexico_City %d-%H:%M}${goto 198}${color3}NYC:${goto 230}${color1}${tztime America/New_York  %d-%H:%M}
# --------------------------------------------------------------------
# SYSTEM info
# --------------------------------------------------------------------
${font :bold:size=10}${color1}SYSTEM ${color4} ${hr 2}${font}
# ${color3}$sysname $kernel ${color1}$alignr $machine
${color3}$sysname ${kernel}${color1}x64${alignr}${color3}Pkgs:${color1}${execi 60 ${template0}}
# ${color3}Package Updates:${alignr}${color1}${execi 10 "${template0}"}${font}
${color3}Load Last 1 Min: ${loadavg 1} $alignr${loadgraph 12,100 00fff3 ff0029 scale -t}
# --------------------------------------------------------------------
# PROCESSORS cpu and gpu info
# --------------------------------------------------------------------
${font :bold:size=10}${color1}PROCESSORS ${color4}${hr 2}${font}
# ${color3}CPU1 ${execi 60 sensors | sed -n '/Core 0/{s/.*:[ ]*+\([0-9]*\).*/\1/p}'}°C ${cpu cpu1}% ${lua main -n bargraph -p 117,234 -w 90 -s 3 -f cpu -a cpu1}$alignr${cpugraph cpu1 12,90 00fff3 ff0029 scale -t}
${color3}CPU1 ${execi 60 cat ${template9}temp2_input| awk '{print $1/1000}'}°C ${cpu cpu1}% ${lua main -n bargraph -p 117,234 -w 90 -s 3 -f cpu -a cpu1}$alignr${cpugraph cpu1 12,90 00fff3 ff0029 scale -t}
${color3}CPU2 ${execi 60 cat ${template9}temp3_input| awk '{print $1/1000}'}°C ${cpu cpu2}% ${lua main -n bargraph -p 117,248 -w 90 -s 3 -f cpu -a cpu2}$alignr${cpugraph cpu2 12,90 00fff3 ff0029 scale -t}
${color3}CPU3 ${execi 60 cat ${template9}temp4_input| awk '{print $1/1000}'}°C ${cpu cpu3}% ${lua main -n bargraph -p 117,261 -w 90 -s 3 -f cpu -a cpu3}$alignr${cpugraph cpu3 12,90 00fff3 ff0029 scale -t}
${color3}CPU4 ${execi 60 cat ${template9}temp5_input| awk '{print $1/1000}'}°C ${cpu cpu4}% ${lua main -n bargraph -p 117,275 -w 90 -s 3 -f cpu -a cpu4}$alignr${cpugraph cpu4 12,90 00fff3 ff0029 scale -t}
${color3}PCH: ${execi 60 cat ${template8}| awk '{print $1/1000}'}°C Fan: ${execi 60 cat ${template7}} rpm ${alignr}Freq: ${freq_g cpu0}Ghz
GPU: ${execi 60 nvidia-smi --query-gpu="temperature.gpu" --format=csv,noheader,nounits}°C Fan: ${execi 60 nvidia-smi --query-gpu="fan.speed" --format=csv,noheader,nounits}%  ${alignr}Mem: ${execi 60 nvidia-smi --query-gpu="memory.used" --format=csv,noheader,nounits} / ${execi 60 nvidia-smi --query-gpu="memory.total" --format=csv,noheader,nounits}mb
# --------------------------------------------------------------------
# NETWORK - internet traffic
# --------------------------------------------------------------------
${font :bold:size=10}${color Tan2}NETWORK ${color4}${hr 2}${font}
${color3}IP on eth0 $alignr ${addr eth0}
${color3}Dn:${offset 18}T:${totaldown eth0} ${color3}$alignr${downspeed eth0} ${alignr}${downspeedgraph eth0 12,100 006964 00fff3 scale -l}
${color3}Up:${offset 18}T:${totalup eth0} ${color3}$alignr${upspeed eth0} ${alignr}${upspeedgraph eth0 12,100 006964 00fff3 scale -l}
# ${if_up ppp0}$font${color3}IP on ppp0 $alignr ${addr ppp0}
# ${color3}Down ${goto 40} T:${totaldown ppp0} $alignr${downspeed ppp0} ${alignr}${downspeedgraph ppp0 12,100 00a39c 00fff3}
# ${color3}Up ${goto 40} T:${totalup ppp0} $alignr ${upspeed ppp0} ${alignr}${upspeedgraph ppp0 12,100 00a39c 00fff3}${else}No ppp0 interface found${endif}
${if_up usb0}$font${color3}IP on usb0 $alignr ${addr usb0}
${color3}Down ${goto 40} T:${totaldown usb0} $alignr${downspeed usb0} ${alignr}${downspeedgraph usb0 12,100 00a39c 00fff3}
${color3}Up ${goto 40} T:${totalup usb0} $alignr ${upspeed usb0} ${alignr}${upspeedgraph usb0 12,100 00a39c 00fff3}${else}No usb0 interface found${endif}
# --------------------------------------------------------------------
# MEMORY - ram
# --------------------------------------------------------------------
${font :bold:size=10}${color1}MEMORY ${color4}${hr 2}${font}
${color3}$mem $memperc% ${lua main -n bargraph -p 117,405 -w 90 -s 1 -f memperc -a NA -l 1 -x 70}${color1}${alignr}${memgraph 12,90 00fff3 ff0029 scale -t}
# --------------------------------------------------------------------
# HDD space on hard drive partitions
# --------------------------------------------------------------------
${font :bold:size=10}${color1}HDD ${color4}${hr 2}${font}
${color1}/System${color5} ${alignr 140}${fs_used /}${alignr 132}${fs_used_perc /}%${lua main -n bargraph -p 190,435 -w 115 -s 1 -f fs_used_perc -a / -l 1 -x 70}
# ${color1}/home${color5}${alignr 145}${fs_used /home}${alignr 132}${fs_used_perc /home}%${lua main bargraph 190 517 115 1 fs_used_perc /home 1 70}
# ${color1}/video_music${color5}${alignr 145}${fs_used /home/param/media/video_music}${alignr 132}${fs_used_perc /home/param/media/video_music}%${lua main bargraph 190 531 115 1 fs_used_perc /home/param/media/video_music 1 70}
# ${color1}/image${color5}${alignr 145}${fs_used /home/param/media/image}${alignr 132}${fs_used_perc /home/param/media/image}%${lua main bargraph 190 545 115 1 fs_used_perc /home/param/media/image 1 70}
# ${color1}/swap${color5}${alignr 145}${swap}${alignr 132}${swapperc}%${lua main bargraph 190 559 115 1 swapperc NA 1 70}
# --------------------------------------------------------------------
# HDD activity
# --------------------------------------------------------------------
${font :bold:size=10}${color1}HDD ACTIVITY${color4}${hr 2}
$font${color3}/dev/sda ${hddtemp /dev/sda}°C ${alignr}Read: ${diskiograph_read /dev/sda 12,70 00fff3 ff0029 scale -t} Write: ${diskiograph_write /dev/sda 12,70 00fff3 ff0029 scale -t -l}
$font${color3}/dev/sdb ${hddtemp /dev/sdb}°C ${alignr}Read: ${diskiograph_read /dev/sdb 12,70 00fff3 ff0029 scale -t} Write: ${diskiograph_write /dev/sdb 12,70 00fff3 ff0029 scale -t -l}
# --------------------------------------------------------------------
# TOP PROCESSES top 5 running process sorted by cpu usage
# --------------------------------------------------------------------
${font :bold:size=10}${color1}TOP PROCESSES ${color4}${hr 2}${font}
${color3}${goto 5}Process Name ${alignr}${goto 130}   PID ${goto 180}  CPU% ${goto 250} Mem%
${top name 1}${goto 130}${top pid 1} ${goto 180}${top cpu 1}   ${goto 250}${top mem 1}
${top name 2}${alignr} ${goto 130}${top pid 2}   ${goto 180}${top cpu 2}    ${goto 250}${top mem 2}
${top name 3}${alignr} ${goto 130}${top pid 3}   ${goto 180}${top cpu 3}    ${goto 250}${top mem 3}
${top name 4}${alignr} ${goto 130}${top pid 4}   ${goto 180}${top cpu 4}    ${goto 250}${top mem 4}
${top name 5}${alignr} ${goto 130}${top pid 5}   ${goto 180}${top cpu 5}    ${goto 250}${top mem 5}
# --------------------------------------------------------------------
# Music info
# --------------------------------------------------------------------
# --------------------------------------------------------------------
# Music info
# --------------------------------------------------------------------
${if_match "${lua if_running audacious}" == "1"}${voffset 2}${font :bold:size=10}${color1}Audacious Playing ${color4}${voffset -2}${hr 2}${font}${lua main -n music_sort -f bold:12 -k 2 -s 5 -p 5,619 -e 0xff700f:1 }${else}#
${if_match "${lua if_running smplayer}" == "1"}${voffset 2}${font :bold:size=10}${color1}SMPlayer Playing ${color4}${voffset -2}${hr 2}${font}${lua main -n music_sort -k 2 -s 5 -p 5,618 }${else}#
${voffset 2}${font :bold:size=10}${color1}No Media${color4}${voffset -2}${hr 1}${font}${endif}${endif}
${voffset 55}${color4}${hr 2}

