#!/bin/bash


#####################################################
### pkgcheck.service - pacman checks for new packages
checkserv='[Unit]
 Description=Automatic new package check
 After=network-online.target

[Service]
 Type=simple
 ExecStart=/usr/bin/pacman -Sy 1>/dev/null 2>&1
 TimeoutStopSec=300
 KillMode=process
 KillSignal=SIGINT

[Install]
 WantedBy=multi-user.target
'

sudo echo "${checkserv}" > /etc/systemd/system/pkgcheck.service

#####################################################
### pkgcheck.timer - runs pkgcheck.service every 180 minutes
checktime='[Unit]
 Description=Automatic check when booted up after 5 minutes then check the system for updates every 180 minutes

[Timer]
 OnBootSec=5min
 OnUnitActiveSec=180min
 Unit=pkgcheck.service

[Install]
 WantedBy=multi-user.target
'

sudo echo "${checktime}" > /etc/systemd/system/pkgcheck.timer

#####################################################
### enable pkgcheck.timer
sudo systemctl enable /etc/systemd/system/pkgcheck.timer

