##########################################################
## VinDSL | Paramvir | rev. 14-04-27 22:12 | ver. 2.0.0 ##
##########################################################

## ¡PLEASE READ THE FINE PRINT! ##

####
## Development Platforms (current)
#
#  Ubuntu 10.10 'Maverick Meerkat' (GNOME 2.28 - Conky 1.8.0-1)
#  Ubuntu 13.04 'Raring Ringtail'  (GNOME-SHELL - UNITY - LXDE - Conky 1.9.0-2)
#  Screen Resolution: 1920x1200x24 (DELL UltraSharp 1907FP)
#
## Tips n' Tricks: conky 1.8.1 will no longer be supported. RIP :)

####
## Prerequisites (required)
#
#  conky-all 1.8.0-1 or 1.9.0-2
#  Conkywx 2.0.0 (Paramvir Likhari)
#  UTF-8 Compatible Text Editor

####
## Installed fonts (required)
#
#  Arrows (JLH Fonts - not included in link below)
#  ConkyWeather (Stanko Metodiev)
#  Cut Outs for 3D FX (Fonts & Things)
#  Droid Font Family (Google Android SDK)
#  KR A Round (Kat's Fun Fonts)
#  Moon Phases (Curtis Clark)
#  OpenLogos (Icoma)
#  PizzaDude Bullets (Jakob Fischer)
#  Radio Space (Iconian Fonts)
#  StyleBats (Vinterstille)
#  Ubuntu Font Family (Canonical Ltd)
#  Ubuntu Title Bold (Paulo Silva - not included in link below)
#  Weather (Jonathan Macagba)
#
## Tips n' Tricks from: Mr. Peachy, djyoung4, and 42dorian (Thanks!)
## Most necessary fonts can be downloaded here: http://ompldr.org/vOHdoag
## Unzip the fonts into your font folder, for example: /home/username/.fonts
## Run this command in a terminal (rebuilds font cache file): sudo fc-cache -fv

####
## Use XFT? Required to Force UTF8 (see below)
#
use_xft yes
xftfont DejaVu Sans Mono:size=12
xftalpha 0.1

####
## Force UTF8? Requires XFT (see above)
## Displays degree symbol, instead of Â°, etc.
#
override_utf8_locale yes

####
## Daemonize Conky, aka 'fork to background'.
#
background yes

####
## Update interval in seconds.
#
update_interval 2.0

####
## The number of times Conky will update before quitting.
## Zero makes Conky run forever.
#
total_run_times 0

####
## Create 'own_window' type. Makes Conky behave like other panels.
#
own_window yes
own_window_transparent yes
own_window_type normal
own_window_hints below,sticky,undecorated,skip_taskbar,skip_pager
own_window_type normal
####
## Some distros require the following lines for true transparency.
## BOTH of these lines need to be Commented/Uncommented in tandem.
#
# own_window_argb_visual true
# own_window_argb_value 255

####
## Force images to redraw when they change.
#
imlib_cache_size 1

####
## Use double buffering? Reduces flicker.
#
double_buffer yes

####
## Draw shades?
#
draw_shades yes
default_shade_color 330

####
## Draw outlines?
#
draw_outline no

####
## Draw borders around text?
#
draw_borders no

####
## Draw borders around graphs?
#
draw_graph_borders no

####
## Print text to stdout?
## Print text in console?
#
out_to_ncurses no
out_to_console no

####
## Text alignment.
#
# alignment top_right
alignment tr
# alignment br

####
## Minimum size of the text area.
## Syntax: minimum_size [width] [height]
#
#minimum_size 245 1394
# minimum_size 245 1894
# minimum_size 300 1080
minimum_size 245 1080
maximum_width 1200


####
## This buffer is used for single lines, text, output from $exec, and other variables.
## Increasing the 'text_buffer_size' (too high) will drastically reduce Conky's performance.
## Decreasing the buffer size (too low) will truncate content and cause strange display output.
## Standard text buffer size is 256 bytes (cannot be less). Adjust YOUR buffer wisely!
## Tips n' Tricks from dk75:"You don't need to create a 12KiB buffer for every Conky config line."
#
text_buffer_size 6200

####
## Maximum number of special things, e.g. fonts, offsets, aligns, etc. (default is 512)
## Tips n' Tricks from: sparker256 (Thanks, Bill!)
#
max_specials 700

####added by me
## Maximum size of user text buffer, i.e. layout below TEXT line in config file (default is 16384 bytes)
# max_user_text 81920
max_user_text 20000

####
## Maximum width of the text area.
## Syntax: maximum_width [width]
#
maximum_width 245
# maximum_width 300

####
## Gap between text and screen borders.
#
gap_x 0
gap_y 32  # Top/Bottom

####
## Shorten MiB/GiB to M/G in stats.
#
short_units yes

####
## Pad % symbol spacing after numbers.
#
pad_percents 0

####
## Pad spacing between text and borders.
#
border_inner_margin 4

####
## Limit the length of names in "Top Processes".
#
top_name_width 10

####
## Subtract file system -/+buffers/cache from used memory?
## Set to yes, to produce meaningful physical memory stats.
#
no_buffers yes

####
## Set to yes, if you want all text to be in UPPERCASE.
#
uppercase no

####
## Number of cpu samples to average.
## Set to 1 to disable averaging.
#
cpu_avg_samples 2

####
## Number of net samples to average.
## Set to 1 to disable averaging.
#
net_avg_samples 2

####
## Add spaces to keep things from moving around?
## Only affects certain objects.
#
use_spacer right

####
## My colors (suit yourself)
#
color0 White            #FFFFFF
color1 Ivory            #FFFFF0
color2 Ivory2           #EEEEE0
color3 yellow           #CDCDC1
color4 Tan1             #FFA54F
color5 cyan             #EE9A49
color6 Gray             #7E7E7E
color7 AntiqueWhite4    #8B8378
color8 DimGray          #696969
color9 Tomato           #FF6347
# colorX OrangeRed        #FF4500

#####
## Load Lua for bargraphs (required)
## Set the path to your script here.
#
# lua_load /usr/share/conkyw/usr/share/conkywx/lib/conkywx.lua
lua_load /usr/share/conkywx/lib/conkywx.lua


####
## Define the locations of Conkywx files (required)
## Set the path to your .confs and templates here.
#
# template0 "/usr/share/conkyw/usr/share/conkywx/conkywx.sh"
template0 ./conkywx.sh
template1 ./examples/conkywx-02.conf
# template1 ./examples/conkywx-02.conf
####
## Choose Graphic or Dingbat template
template4 ./examples/vindsl-weather-graphic-template.sh
# template4 "\"$WX_DI./examples/vindsl-weather-dingbat-template.sh\""
####
template7 /tmp/wx-param-vindsl-conkywx.conf-pChA_r_27u0-m39/wxalert

## To switch between Imperial and Metric change template9 to F for Imperial or C for Metric values - template4 file does not require any change - it changes based on Units_to_Use in the vindsl-conkywx.conf file
template9 C

TEXT
${voffset -9}${lua main -n background -r 45 -c 0x000000:0.2 -s NA,NA}
##################################
##             LOGO             ##
##################################
## Uncomment for hard-coded ID (static)
# ${voffset -33}${font OpenLogos:size=103}${color2}v${font}${voffset -75}${goto 179}${font UbuntuTitleBold:size=19.6}${color4}1${offset 1}2${offset 1}.${offset 0}0${offset 0}4${font}
####
## Uncomment for soft-coded ID (dynamic)
# ${voffset -30}${font OpenLogos:size=93}${color2}v${font}${voffset -75}${goto 179}${font UbuntuTitleBold:size=12.6}${color4}${pre_exec cat /etc/*release | grep 'RELEASE' | awk -F'=' '{print $2}'}${font}
####
##  Uncomment For Arch Linux
${voffset 0}${font OpenLogos:size=24}${color2}B${font}${voffset -20}${goto 50}${font UbuntuTitleBold:size=24}${color4}${pre_exec cat /etc/*release | grep 'PRETTY_NAME'| sed 's/.*="\(.*\)"/\1/' }${font}
####
## Additional ID (branch version, code name, release date, etc.)
# ${voffset -2}${goto 181}${font Ubuntu-B:bold:size=7.55}${color5}Conky ${conky_version}${font}
# ${voffset 0}${goto 181}${font Ubuntu-B:size=8}${color4}Pre-Alpha${font}
####
## Uncomment to display YOUR custom graphic image (upper-right corner)
#${voffset -30}${font OpenLogos:size=103}${color2}v${font}${voffset -52}${image /home/cavsfan/Pictures/ABC.jpg -p 180,0 -s 52x52 -n}

##################################
##            SYSTEM            ##
##################################
${voffset -7}${font DroidSans:bold:size=8.25}${color4}SYSTEM${offset 8}${color6}${voffset -2}${hr 1}${font}
# ${voffset 4}${font OpenLogos:size=10}${color2}u${voffset -4}${font DroidSans:size=8.6}${color0}${offset 5}${pre_exec lsb_release -sd | sed -e 's/development/dev/g'}${alignr}${pre_exec lsb_release -sr}${font}
${voffset 2}${offset -2}${font OpenLogos:size=12}${color2}Z${voffset -4}${font DroidSans:size=8.6}${color0}${offset 3}${sysname}${offset 3}${kernel}${alignr}${font DroidSans:size=8.3}${machine}${font}
####
## Uncomment for nVidia ID (nvidia-smi version - dynamic)
${voffset 2}${font StyleBats:size=10}${color2}d${voffset -2}${font DroidSans:size=8.6}${color0}${offset 5}${pre_exec nvidia-smi -q | grep "Product Name" | sed -e 's/.*: /nVidia /'}${alignr}${pre_exec nvidia-smi -q | grep "Driver Version" | awk '{print $4}'}${font}
####
## Uncomment for 'nvidia-current' driver ID (DPKG version - hybrid)
# ${voffset 2}${font StyleBats:size=10}${color2}d${voffset -2}${font DroidSans:size=8.6}${color0}${offset 5}nVidia GeForce 7600 GT${alignr}${font DroidSans:size=8.3}${pre_exec dpkg --status nvidia-current | grep Version | cut -f 1 -d '-' | sed 's/[^.,0-9]//g'}${font}
####
## Uncomment for nvidia driver ID (OpenGL version - hydrid)
# ${voffset 2}${font StyleBats:size=10}${color2}d${voffset -2}${font DroidSans:size=8.6}${color0}${offset 5}nVidia GeForce 7600 GT${alignr}${font DroidSans:size=8.3}${pre_exec glxinfo | grep 'OpenGL version string' | sed -e 's/OpenGL.*: //' | cut -c '14-19'}${font}
####
## Uncomment for hard-coded video ID (any card / any driver - static)
# ${voffset 2}${font StyleBats:size=10}${color2}d${voffset -2}${font DroidSans:size=8.6}${color0}${offset 5}Video Card Product Name${alignr}Driver Version${font DroidSans:size=8.3}${font}
####
## Uncomment for CPU ID / CPU frequency (hybrid)
# ${voffset 2}${font StyleBats:size=10}${color2}A${voffset -1}${font DroidSans:size=8.6}${color0}${offset 5}Intel${offset 3}Core${offset 3}2${offset 3}Quad Q9550${alignr 1}${font DroidSans:size=8.3}${freq_g cpu0}${offset 1}GHz${font}
${voffset 2}${font StyleBats:size=10}${color2}A${voffset -1}${font DroidSans:size=8.6}${color0}${offset 5}Intel${offset 3}Multi${offset 3}Core${alignr 1}${font DroidSans:size=8.3}${freq_g cpu0}${offset 1}GHz${font}
####
## Uncomment for System Uptime (hybrid)
${voffset 2}${font StyleBats:size=10}${color2}q${voffset -1}${font DroidSans:size=8.6}${color0}${offset 5}System${offset 3}Uptime${alignr}${font DroidSans:size=8.3}${uptime_short}${font}
## uncoment for grub version
# ${voffset 2}${font OpenLogos:size=10}${color2}u${voffset -1}${font DroidSans:size=8.6}${color0}${offset 5}Grub${offset 3}Version${alignr}${font DroidSans:size=8.3}${pre_exec grub-install -v | grep grub-install | cut -c21-42}${font}
##################################
##      PROCESSORS+TEMPS        ##
##################################
${voffset 4}${font DroidSans:bold:size=8}${color4}PROCESSORS+TEMPS${offset 8}${color6}${voffset -2}${hr 1}${font}
${voffset 4}${font StyleBats:size=9.9}${color2}k${voffset -2}${font DroidSansFallback:size=8.39}${color0}${offset 2}CPU1${offset 5}${font DroidSans:size=8.3}${cpu cpu1}%$alignr${if_match "${template9}" == "C"}${execi 600 sensors | grep 'Core 0' | sed 's/.*+\(.*\)  \(.*\)/\1/'}${else}${execi 600 sensors -f | grep 'Core 0' | sed 's/.*+\(.*\)  \(.*\)/\1/'}${endif}${font}
${voffset 2}${font StyleBats:size=9.9}${color2}k${voffset -2}${font DroidSansFallback:size=8.39}${color0}${offset 2}CPU2${offset 5}${font DroidSans:size=8.3}${cpu cpu2}%$alignr${if_match "${template9}" == "C"}${execi 600 sensors | grep 'Core 1' | sed 's/.*+\(.*\)  \(.*\)/\1/'}${else}${execi 600 sensors -f | grep 'Core 1' | sed 's/.*+\(.*\)  \(.*\)/\1/'}${endif}${font}
${voffset 2}${font StyleBats:size=9.9}${color2}k${voffset -2}${font DroidSansFallback:size=8.39}${color0}${offset 2}CPU3${offset 5}${font DroidSans:size=8.3}${cpu cpu3}%$alignr${if_match "${template9}" == "C"}${execi 600 sensors | grep 'Core 2' | sed 's/.*+\(.*\)  \(.*\)/\1/'}${else}${execi 600 sensors -f | grep 'Core 2' | sed 's/.*+\(.*\)  \(.*\)/\1/'}${endif}${font}
${voffset 2}${font StyleBats:size=9.9}${color2}k${voffset -2}${font DroidSansFallback:size=8.39}${color0}${offset 2}CPU4${offset 5}${font DroidSans:size=8.3}${cpu cpu4}%$alignr${if_match "${template9}" == "C"}${execi 600 sensors | grep 'Core 3' | sed 's/.*+\(.*\)  \(.*\)/\1/'}${else}${execi 600 sensors -f | grep 'Core 3' | sed 's/.*+\(.*\)  \(.*\)/\1/'}${endif}${font}
${voffset 4}${font StyleBats:size=9.9}${color2}k${voffset -2}${font DroidSansFallback:size=8.39}${color0}${offset 2}GPU Temperature: $alignr${if_match "${template9}" == "C"}${execi 10 nvidia-settings -q GPUCoreTemp | awk '{if (NR==2) {print ($4*1)}}'}°C${else}${execi 10 nvidia-settings -q GPUCoreTemp | awk '{if (NR==2) {print ($4*9)/5+32}}'}°F${endif}#
${lua main -n bargraph -p 90,149 -w 120 -s 3 -f cpu -a cpu1}#
${lua main -n bargraph -p 90,164 -w 120 -s 3 -f cpu -a cpu2}#
${lua main -n bargraph -p 90,179 -w 120 -s 3 -f cpu -a cpu3}#
${lua main -n bargraph -p 90,194 -w 120 -s 3 -f cpu -a cpu4}
##################################
##            MEMORY            ##
##################################
${voffset 5}${font DroidSans:bold:size=8}${color4}MEMORY${offset 8}${color6}${voffset -2}${hr 1}${font}
${voffset 6}${font StyleBats:size=10}${color2}l${voffset -2}${font DroidSansFallback:size=8.3}${color0}${offset 3}RAM${goto 97}${font DroidSans:size=8.3}${mem}${goto 133}/${offset 5}${memmax}${alignr}${memperc}%${font}#
${lua main -n bargraph -p 20,259 -w 235 -s 1 -f memperc -a NA -l 1 -x 70}
##################################
##             HDD              ##
##################################
${voffset 12}${font DroidSans:bold:size=8}${color4}HDD${offset 8}${color6}${voffset -2}${hr 1}${font}
${voffset 5}${font StyleBats:size=9.9}${color2}x${voffset -2}${font DroidSansFallback:size=8.3}${color0}${offset 4}ROOT${goto 95}${font DroidSans:size=8.3}${fs_used /}${goto 133}/${offset 5}${fs_size /}${alignr}${fs_free_perc /}% / ${fs_used_perc /}%${font}
${voffset 13}${font StyleBats:size=9.9}${color2}x${voffset -2}${font DroidSansFallback:size=8.3}${color0}${offset 4}HOME${goto 95}${font DroidSans:size=8.3}${if_existing /home}${fs_used /home}${goto 133}/${offset 5}${fs_size /home}${alignr}${fs_free_perc /home}% / ${fs_used_perc /home}%${font}${endif}
${voffset 13}${font StyleBats:size=9.9}${color2}4${voffset -2}${font DroidSansFallback:size=8.3}${color0}${offset 4}SWAP${goto 95}${font DroidSans:size=8.3}${swap}${goto 133}/${offset 5}${swapmax}${alignr}${swapperc}%${font}#
${lua main -n bargraph -p 20,301 -w 235 -s 1 -f fs_used_perc -a / -l 1 -x 70}#
${lua main -n bargraph -p 20,327 -w 235 -s 1 -f fs_used_perc -a /home -l 1 -x 70}
##################################
##         TEMPERATURES         ##
##################################
# ${voffset 1}${font DroidSans:bold:size=8}${color4}CPU/GPU TEMPERATURES${offset 8}${color6}${voffset -2}${hr 1}${font}
# ${voffset 4}${font StyleBats:size=9.9}${color2}k${voffset -2}${font DroidSansFallback:size=8.39}${color0}${offset 2}CPU Core 1 Temp: $alignr${execi 600 sensors -f | grep 'Core 0' | awk '{print $3}' | cut -c2-9}
# ${voffset 4}${font StyleBats:size=9.9}${color2}k${voffset -2}${font DroidSansFallback:size=8.39}${color0}${offset 2}CPU Core 2 Temp: $alignr${execi 600 sensors -f | grep 'Core 1' | awk '{print $3}' | cut -c2-9}
# ${voffset 4}${font StyleBats:size=9.9}${color2}k${voffset -2}${font DroidSansFallback:size=8.39}${color0}${offset 2}CPU Core 3 Temp: $alignr${execi 600 sensors -f | grep 'Core 2' | awk '{print $3}' | cut -c2-9}
# ${voffset 4}${font StyleBats:size=9.9}${color2}k${voffset -2}${font DroidSansFallback:size=8.39}${color0}${offset 2}CPU Core 4 Temp: $alignr${execi 600 sensors -f | grep 'Core 3' | awk '{print $3}' | cut -c2-9}
# ${voffset 4}${font StyleBats:size=9.9}${color2}k${voffset -2}${font DroidSansFallback:size=8.39}${color0}${offset 2}GPU Temperature: $alignr${execi 10 nvidia-settings -q GPUCoreTemp | awk '{if (NR==2) {print ($4*9)/5+32}}'}°F
##################################
##         TOP PROCESSES        ##
##################################
${voffset 6}${font DroidSans:bold:size=8}${color4}TOP PROCESSES${offset 8}${color6}${voffset -2}${hr 1}${font}
${voffset 6}${font StyleBats:size=10}${color1}h${voffset -1}${font DroidSans:size=8.65}${color0}${offset 5}${top_mem name 1}${goto 120}${font DroidSans:size=8.3}${top_mem mem_res 1}${alignr}${top_mem mem 1}%${font}
${voffset 1}${font StyleBats:size=10}${color1}h${voffset -1}${font DroidSans:size=8.65}${color0}${offset 5}${top_mem name 2}${goto 120}${font DroidSans:size=8.3}${top_mem mem_res 2}${alignr}${top_mem mem 2}%${font}
${voffset 1}${font StyleBats:size=10}${color1}h${voffset -1}${font DroidSans:size=8.65}${color0}${offset 5}${top_mem name 3}${goto 120}${font DroidSans:size=8.3}${top_mem mem_res 3}${alignr}${top_mem mem 3}%${font}
#${voffset 1}${font StyleBats:size=10}${color1}h${voffset -1}${font DroidSans:size=8.65}${color0}${offset 5}${top_mem name 4}${goto 120}${font DroidSans:size=8.3}${top_mem mem_res 4}${alignr}${top_mem mem 4}%${font}
#${voffset 1}${font StyleBats:size=10}${color1}h${voffset -1}${font DroidSans:size=8.65}${color0}${offset 5}${top_mem name 5}${goto 120}${font DroidSans:size=8.3}${top_mem mem_res 5}${alignr}${top_mem mem 5}%${font}
#${voffset 1}${font StyleBats:size=10}${color1}h${voffset -1}${font DroidSans:size=8.65}${color0}${offset 5}${top_mem name 6}${goto 120}${font DroidSans:size=8.3}${top_mem mem_res 6}${alignr}${top_mem mem 6}%${font}
#${voffset 1}${font StyleBats:size=10}${color1}h${voffset -1}${font DroidSans:size=8.65}${color0}${offset 5}${top_mem name 7}${goto 120}${font DroidSans:size=8.3}${top_mem mem_res 7}${alignr}${top_mem mem 7}%${font}
#${voffset 1}${font StyleBats:size=10}${color1}h${voffset -1}${font DroidSans:size=8.65}${color0}${offset 5}${top_mem name 8}${goto 120}${font DroidSans:size=8.3}${top_mem mem_res 8}${alignr}${top_mem mem 8}%${font}
#${voffset 1}${font StyleBats:size=10}${color1}h${voffset -1}${font DroidSans:size=8.65}${color0}${offset 5}${top_mem name 9}${goto 120}${font DroidSans:size=8.3}${top_mem mem_res 9}${alignr}${top_mem mem 9}%${font}
#${voffset 1}${font StyleBats:size=10}${color1}h${voffset -1}${font DroidSans:size=8.65}${color0}${offset 5}${top_mem name 10}${goto 120}${font DroidSans:size=8.3}${top_mem mem_res 10}${alignr}${top_mem mem 8}%${font}
##################################
##          NETWORK             ##
##################################
${voffset 4}${font DroidSans:bold:size=8}${color4}NETWORK${offset 8}${color6}${voffset -2}${hr 1}${font}
${voffset 4}${font PizzaDudeBullets:size=9.5}${color6}T${font DroidSans:size=8.65}${color0}${offset 5}Download${goto 120}${font DroidSans:size=8.3}${totaldown eth0}${alignr}${font DroidSans:size=8.3}${downspeed eth0}${font}
${voffset 0}${font PizzaDudeBullets:size=9.5}${color6}N${font DroidSans:size=8.65}${color0}${offset 5}Upload${goto 120}${font DroidSans:size=8.3}${totalup eth0}${alignr}${font DroidSans:size=8.3}${upspeed eth0}${font}
${voffset 4}${font PizzaDudeBullets:size=9.5}${color6}a${font DroidSans:size=8.65}${color0}${offset 5}Private${offset 3}IP${goto 123}${font DroidSansFallback:size=8.5}LAN${alignr}${font DroidSans:size=8.3}${addr eth0}${font}
# ${voffset 0}${font PizzaDudeBullets:size=9.5}${color6}a${font DroidSans:size=8.65}${color0}${offset 5}Public${offset 7}IP${goto 121}${font DroidSansFallback:size=8.5}WAN${alignr}${font DroidSans:size=8.3}${execi 1800 wget -q -o /dev/null -O - checkip.dyndns.org | sed -e 's/[^[:digit:]\|.]//g'}${font}
#${voffset 0}${font PizzaDudeBullets:size=9.5}${color6}a${font DroidSans:size=8.65}${color0}${offset 5}Public${offset 7}IP${goto 121}${font DroidSansFallback:size=8.5}WAN${alignr}${font DroidSans:size=8.3}ha ha
##################################
##      CONKYWX WEATHER         ##
##################################
${voffset 4}${font DroidSans:bold:size=8.25}${color4}CONKYWX${if_existing ${template7}} ${color5}Alert:${font}${lua main -n scroller -f 12 -l 21 -s 5 -p 98,504 -o ${template7}}${else} ${color6}${hr 1}${endif}
####
## Uncomment for IMPERIAL Weather Stats (GRAPHIC icon set).
${execpi 900 ${template0} -c "${template1}" -t "${template4}"}${font}
##################################
##           TIME               ##
##################################
${voffset 5}${font DroidSans:bold:size=8}${color4}TIME${offset 8}${color6}${voffset -2}${hr 1}${font}
${voffset -10}${font RadioSpace:size=32}${color0}${if_match ${time %l}<=9}${alignc 7}${time %l:%M}${offset 3}${time %p}${else}${if_match ${time %l}>=10}${alignc -1}${time %l:%M}${offset 3}${time %p}${endif}${endif}${font}
##################################
##         CALENDAR             ##
##################################
${voffset 4}${font DroidSans:bold:size=8}${color4}DATE${offset 8}${color6}${voffset -2}${hr 1}${font}
${voffset 18}${font DroidSansMono:size=7.55}${color2}${alignc 60}${time %A}${font}
${voffset -4}${font DroidSansFallback:bold:size=18}${if_match ${time %e}<=9}${color0}${alignc 65}${time %e}${font}${else}${if_match ${time %e}>=10}${color0}${alignc 60}${time %e}${endif}${endif}${font}
${voffset 0}${font DroidSansMono:size=7.55}${color2}${alignc 60}${time %B}${font}
${voffset 0}${font DroidSansMono:size=7.6}${color2}${alignc 60}${time %Y}${font}
${voffset -80}${font CutOutsFor3DFX:size=67}${color7}${alignc 99}2${font}
####
## Uncomment for "SUNDAY = First Day-of-the-Week" (use mono fonts only)
${voffset -70}${font DroidSansMono:size=7.55}${color0}${execpi 60 VinDSL_Cal_9=`date +%-d`; cal | sed -e 's/\r//g' -e 's/^/ /g' -e '1d' -e s/^/"\$\{offset 100"\}/ -e 's/\<'"$VinDSL_Cal_9"'\>/${color4}&${color0}/'}
# ${execpi 60 my_cal=$(date +%-d); cal | sed 's/\<'$my_cal'\>/${color1}&${color3}/g'}
####
## Uncomment for "MONDAY = First Day-of-the-Week" (use mono fonts only)
# ${voffset -68}${font DroidSansMono:size=7.55}${color0}${execpi 60 VinDSL_Cal_9=`date +%-d`; ncal -M -C -h | sed -e 's/\r//g' -e 's/^/ /g' -e '1d' -e s/^/"\$\{offset 100"\}/ -e 's/\<'"$VinDSL_Cal_9"'\>/${color4}&${color0}/'}
# ##################################
# ##  RHYTHMBOX 1 (Experimental)  ##
# ##################################
# #${if_running rhythmbox}
# #${voffset -13}${font DroidSans:bold:size=8}${color4}RHYTHMBOX${offset 8}${color6}${voffset -2}${hr 1}${font}
# #${voffset 2}${font DroidSans:size=8.25}${color2}${if_match "${execpi 2 expr length "`/usr/bin/rhythmbox-client --print-playing-format %tt | head -n 1`"}" >= "48"}${alignr 15}${scroll 38 4* ${execi 2 rhythmbox-client --print-playing-format %tt --no-start}}${font}${else}${alignc}${execi 2 rhythmbox-client --print-playing-format %tt --no-start}${font}${endif}${endif}
# ##################################
# ##  RHYTHMBOX 2 (Experimental)  ##
# ##################################
# ${if_running rhythmbox}
# ${voffset -13}${font DroidSans:bold:size=8}${color4}RHYTHMBOX${offset 8}${color6}${voffset -2}${hr 1}${font}
# ${voffset 5}${font DroidSans:size=8.25}${color2}${if_match "${execpi 2 expr length "`qdbus org.mpris.MediaPlayer2.rhythmbox /\org/mpris/MediaPlayer2 org.mpris.MediaPlayer2.Player.Metadata | grep title | cut -c 14-""`"}" >= "48"}${alignr 15}${scroll 38 4* ${execi 2 qdbus org.mpris.MediaPlayer2.rhythmbox /\org/mpris/MediaPlayer2 org.mpris.MediaPlayer2.Player.Metadata | grep title | cut -c 14-""}}${font}${else}${alignc}${execi 2 qdbus org.mpris.MediaPlayer2.rhythmbox /\org/mpris/MediaPlayer2 org.mpris.MediaPlayer2.Player.Metadata | grep title | cut -c 14-""}${font}${endif}${endif}
# ##################################
# ##    BANSHEE (Experimental)    ##
# ##################################
# ${if_running banshee}
# ${voffset -26}${font DroidSans:bold:size=8}${color4}BANSHEE${offset 8}${color6}${voffset -2}${hr 1}${font}
# ${voffset 3}${font DroidSans:size=8.25}${color0}${if_match "${execpi 2 expr length "`/usr/bin/banshee --query-title --no-present | cut -f1- -d " "`"}" >= "48"}${alignr 15}${scroll 38 4* ${execi 2 banshee --query-title --no-present | cut -f2- -d " "}}${font}${else}${alignc}${execi 2 banshee --query-title --no-present | cut -f2- -d " "}${font}${endif}${endif}
# ##################################
# ##   GUAYADEQUE (Experimental)  ##
# ##################################
# ${if_running guayadeque}
# ${voffset -36}${font DroidSans:bold:size=8}${color4}GUAYADEQUE${offset 8}${color6}${voffset -2}${hr 1}${font}
# ${voffset 4}${font DroidSans:size=8.25}${color0}${if_match "${execpi 2 expr length "`qdbus org.mpris.guayadeque /\Player org.freedesktop.MediaPlayer.GetMetadata | grep title | cut -f2- -d" "`"}" >= "48"}${alignr 15}${scroll 38 4* ${execi 2 qdbus org.mpris.guayadeque /\Player org.freedesktop.MediaPlayer.GetMetadata | grep title | cut -f2- -d" "}}${font}${else}${alignc}${execi 2 qdbus org.mpris.guayadeque /\Player org.freedesktop.MediaPlayer.GetMetadata | grep title | cut -f2- -d" "}${font}${endif}${endif}
# ##################################
# ##     VLC (Experimental)       ##
# ##################################
${if_running vlc}${voffset 10}${font DroidSans:bold:size=8}${color4}VLC${offset 8}${color6}${voffset -2}${hr 1}${font}${lua main -n music_sort -f 14 -l 36 -s 5 -p 5,1005 -c 0x00ff00:1 }${endif}
# ##################################
# ##     SMPlayer (Experimental)       ##
# ##################################
${if_running smplayer}${voffset 10}${font DroidSans:bold:size=8}${color4}SMPlayer${offset 8}${color6}${voffset -2}${hr 1}${font}${lua main -n music_sort -f 14 -l 36 -s 5 -p 5,1005 -c 0x00ff00:1 }${endif}
# ##################################
# ##     Audaciuos                ##
# ##################################
# # ${if_running audacious}
# # ${voffset -70}${font DroidSans:bold:size=8}${color4}Audacious${offset 8}${color6}${voffset -2}${hr 2}$font$
# # ${voffset -3}${font DroidSans:bold:size=8}${color6}${audacious_title 250}
# # ${color4}${audacious_bar 10,250 }${color6}
# # ${audacious_position}/${audacious_length}  Sample Rate${alignc} ${audacious_frequency} Hz ${alignr}${audacious_status}${endif}
######################################
#### This font statement below is required for conky to reset the font before it draws the shades to align the text shadows correctly in *draw_shades yes*
${font}

