
--[[
    paramvir 2017

    vumeter how to ;-)
    label         = name of the widget
    textColour    = colour of text
    pointerColour = colour of pointer
    numberColour  = colour of numbers
    colourStop    = {0,0.7,1}  table with colour stops
    startColour   = {red,0.9},
    midColour     = {brown,0.5},
    endColour     = {lime,0.3},
    unitToShow    = " Max: ${maxuv}", only this variable has variable expansion like in bash
                        the required variables are maxuv and moonState inclose them in ${}
    maxDivisor    = 1,  the widget has support to show 1 to 10 - is anything closer to 10
                        make this 1 or is like moon then 100
    vhstyle       = 'V', style vertical or horizontal

]]



local white  = 0xffffff
local orange = 0xE37222
local tan1   = 0xff2500
local yellow = 0xffff00
local cyan   = 0x00ffff
local lime   = 0x00ff00
local pink   = 0xff00ff
local blue   = 0x0000ff
local brown  = 0xCD950C
local red    = 0xff0000


local w = {}

w.vuData = {
    U = {
        label             = "UV",
        textColour        = {yellow,1},
        pointerColour     = {blue,1},
        numberColour      = {lime,0.8},
        colourStop        = {0,0.7,1},
        startColour       = {red,0.9},
        midColour         = {brown,0.5},
        endColour         = {lime,0.3},
        unitToShow        = " Max: ${maxuv}",
        maxDivisor        = 1,
        vhstyle           = 'V',
        showOriginalValue = 1,
    },
    P = {
        label             = "Pollen",
        textColour        = {yellow,1},
        pointerColour     = {blue,1},
        numberColour      = {lime,0.8},
        colourStop        = {0,0.7,1},
        startColour       = {red,0.9},
        midColour         = {brown,0.5},
        endColour         = {lime,0.3},
        unitToShow        = "",
        maxDivisor        = 1,
        vhstyle           = 'V',
        showOriginalValue = 1,
    },
    V = {
        label         = "Visibility",
        textColour    = {0xFFFF00,1},
        pointerColour = {0xff00ff,1},
        numberColour  = {0x00f0FF,0.7},
        colourStop    = {0,0.5,1},
        startColour   = {0xB9B9B9,0},
        midColour     = {0xB9B9B9,0.2},
        endColour     = {0xB9B9B9,1},
        unitToShow    = ' km',
        maxDivisor    = 1,
        vhstyle       = 'H',
    },
    H = {
        label         = "R Humidity",
        textColour    = {0x00ffff,1},
        pointerColour = {0xff00ff,1},
        numberColour  = {0x00FF00,0.7},
        colourStop    = {0,0.5,1},
        startColour   = {0x4169E1,1},
        midColour     = {0x4169E1,0.5},
        endColour     = {0x4169E1,0},
        unitToShow    = '% x10',
        maxDivisor    = 10,
        vhstyle       = 'V',
    },
    M = {
        label         = "Moon",
        textColour    = {0x00ffff,1},
        pointerColour = {0xff00ff,1},
        numberColour  = {0x00FF00,0.7},
        colourStop    = {0,0.3,1},
        startColour   = {0xFFFFff,0.5},
        midColour     = {0xb0b0b0,0.4},
        endColour     = {0x000000,0.3},
        unitToShow    = '% x10 ${moonState}',
        maxDivisor    = 10,
        vhstyle       = 'H',
    },
}

return w

