#!/bin/bash

## --------------------------------------------------------------------
## Conkywx wxrelocate Utility | Paramvir | rev. 24-11-2015 | ver. 1.0.0
## --------------------------------------------------------------------
## CAVEAT: No guarantee that this program will work on all platforms,
## Use At Your Own Risk.
## --------------------------------------------------------------------

mvdir="$1"

#debug='true'
# This defines the output of set -x debugging xtrace
if [[ $debug ]]; then
	rm -rf '/tmp/relocatedebug'
	export PS4='+ (${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
	exec 4>>'/tmp/relocatedebug'
	BASH_XTRACEFD=4
	set -x
fi

msgout() { printf "\n%b\n" "$1" >&2; }

usage() {
cat << helpmsg

Program: wxrelocate

Basic options:
 -h|--help              - view this help screen

Usage:   wxrelocate [path]
	Give the path for the folder you want to copy the conkywx/examples
	folder to.

	Note:: User home folder is already taken into account
	example::
		./wxrelocate "/bin/conkywx/examples"
	this will internally translate to::
		./wxrelocate "/home/username/bin/conkywx/examples"

helpmsg
}

if [[ "$mvdir" ]]; then
	case "$mvdir" in
	-h|--help) 	usage; exit 0
		;;
	*)
		NewExamplesFolder="${HOME}/${mvdir}"
		NewExamplesFolder="${NewExamplesFolder//\/\//\/}"

		mkdir -p "$NewExamplesFolder"

		if [[ -d "$NewExamplesFolder" ]]; then
			cd "$NewExamplesFolder"
		else
			msgout "\n\n Error :( Not able to create "$NewExamplesFolder". \n"
			exit 1
		fi
		;;
	esac

	cp /usr/share/conkywx/examples/* .
	cp /usr/share/conkywx/conky-restart.sh .

	sed -i 's`^WX_DIR=.*`WX_DIR=\"\'"${PWD%\/*}"'\"\ncd /usr/share/conkywx`' conky-restart.sh

	sed -i 's`./lib/conkywx.lua`/usr/share/conkywx/lib/conkywx.lua`' *rc*
	sed -i 's`./conkywx.sh`/usr/share/conkywx/conkywx.sh`' *rc*
	sed -i 's`./examples/`'"${PWD}"'/`' *rc*
else
	usage; exit 0
fi

if [[ $debug ]]; then set +x ; fi

exit 0


