
--[[
    modified Paramvir 2017 - added folder-size option
    This is the data file for wxrings.lua
    du give values in kilobytes. the max_size will be the max size of folder you want - like a limit and based on that you will see a ring using percentage of du value off max_size

]]

local w = {true}

local white  = 0xffffff
local orange = 0xE37222
local tan1   = 0xff2500
local yellow = 0xffff00
local cyan   = 0x00ffff
local lime   = 0x00ff00
local pink   = 0xff00ff

local graph_radius = 65
local graph_radius_fact = 7

-- default theme
w.dt = {
    ----- cpu location settings-------------------------
    cpu_x                 = 70,
    cpu_y                 = 312,
    cpu_graph_radius      = graph_radius,
    cpu_graph_radius_fact = graph_radius_fact,
    ----- mem location settings-------------------------
    mem_x                 = 170,
    mem_y                 = 312,
    mem_graph_radius      = graph_radius,
    mem_graph_radius_fact = graph_radius_fact,
    ----- net location settings-------------------------
    net_x                 = 275,
    net_y                 = 312,
    net_graph_radius      = graph_radius,
    net_graph_radius_fact = graph_radius_fact,
    ----- common settings-------------------------------
    graph_thickness       = 2.5,
    max_value             = 100,
    downloadMax           = 6300, -- use speedtest.net to calibrate up down stuff
    uploadMax             = 6300, -- use speedtest.net to calibrate up down stuff
    graph_start_angle     = 180, --180
    graph_unit_angle      = 1.8, -- based on 360/100 - ANGLE/100
    graph_unit_thickness  = 1.8, -- make this same as graph_unit_angle for smoothness
    hand_type             = 1,   -- 1 for dots nil for slots
    hand_thickness        = 2.5, -- orange bit - used direct not part of gauge table
    textOffset            = 3.0, -- used direct not part of gauge table
    graph_bg_colour       = {white, 0.05 }, -- needs adjustment based on background
    -- graph_fg_colour       = {cyan,  0.15 },
    graph_fg_colour       = nil,  -- nil to use colour blend
    blend_alpha           = 0.35, -- for colour blend based on % use
    blend_midpoint        = 65,   -- how soon you want the red colour mix
    hand_fg_colour        = {tan1,   0.7 }, -- indicator dot
    txt_fg_colour         = {yellow, 0.7 },
    grad_fg_colour        = {white,  0.3 },
    caption_fg_colour     = {white,  1 },
    fontName              = 'DroidSansFallback',
    peakDurationDisplay   = 15,
    peak_fg_colour        = {white,   0.5 },
}


-- CPU rings
w.gauge = {
    {
        name                 = 'cpu',
        arg                  = 'cpu1',
        max_value            = w.dt.max_value,
        x                    = w.dt.cpu_x,
        y                    = w.dt.cpu_y,
        graph_radius         = w.dt.cpu_graph_radius,
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.cpu_graph_radius,
        txt_weight           = 0,
        txt_on_base          = 1,
        txt_size             = 9.5,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 28,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = '1',
        caption_weight       = 0.8,
        caption_size         = 8.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'c1'
    },
    {
        name                 = 'sysinfo',
        arg                  = 'cpu1',
        max_value            = w.dt.max_value,
        x                    = w.dt.cpu_x,
        y                    = w.dt.cpu_y,
        graph_radius         = w.dt.cpu_graph_radius - w.dt.cpu_graph_radius_fact,
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.cpu_graph_radius - w.dt.cpu_graph_radius_fact,
        txt_weight           = 1,
        txt_on_base          = nil,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 28,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = '',
        caption_weight       = 0.8,
        caption_size         = 8.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'c2'
    },
    {
        name                 = 'cpu',
        arg                  = 'cpu2',
        max_value            = w.dt.max_value,
        x                    = w.dt.cpu_x,
        y                    = w.dt.cpu_y,
        graph_radius         = w.dt.cpu_graph_radius - (w.dt.cpu_graph_radius_fact * 2),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.cpu_graph_radius - (w.dt.cpu_graph_radius_fact * 2),
        txt_weight           = 1,
        txt_on_base          = 1,
        txt_size             = 9.5,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 28,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = '2',
        caption_weight       = 0.8,
        caption_size         = 8.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'c3'
    },
    {
        name                 = 'sysinfo',
        arg                  = 'cpu2',
        max_value            = w.dt.max_value,
        x                    = w.dt.cpu_x,
        y                    = w.dt.cpu_y,
        graph_radius         = w.dt.cpu_graph_radius - (w.dt.cpu_graph_radius_fact * 3),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.cpu_graph_radius - (w.dt.cpu_graph_radius_fact * 3),
        txt_weight           = 1,
        txt_on_base          = nil,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 28,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = '',
        caption_weight       = 0.8,
        caption_size         = 8.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'c4'
    },
    {
        name                 = 'cpu',
        arg                  = 'cpu3',
        max_value            = w.dt.max_value,
        x                    = w.dt.cpu_x,
        y                    = w.dt.cpu_y,
        graph_radius         = w.dt.cpu_graph_radius - (w.dt.cpu_graph_radius_fact * 4),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.cpu_graph_radius - (w.dt.cpu_graph_radius_fact * 4),
        txt_weight           = 0,
        txt_on_base          = 1,
        txt_size             = 9.5,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 28,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = '3',
        caption_weight       = 0.8,
        caption_size         = 8.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'c5'
    },
    {
        name                 = 'sysinfo',
        arg                  = 'cpu3',
        max_value            = w.dt.max_value,
        x                    = w.dt.cpu_x,
        y                    = w.dt.cpu_y,
        graph_radius         = w.dt.cpu_graph_radius - (w.dt.cpu_graph_radius_fact * 5),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.cpu_graph_radius - (w.dt.cpu_graph_radius_fact * 5),
        txt_weight           = 1,
        txt_on_base          = nil,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 28,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = '',
        caption_weight       = 0.8,
        caption_size         = 8.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'c6'
    },
    {
        name                 = 'cpu',
        arg                  = 'cpu4',
        max_value            = w.dt.max_value,
        x                    = w.dt.cpu_x,
        y                    = w.dt.cpu_y,
        graph_radius         = w.dt.cpu_graph_radius - (w.dt.cpu_graph_radius_fact * 6),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.cpu_graph_radius - (w.dt.cpu_graph_radius_fact * 6),
        txt_weight           = 0,
        txt_on_base          = 1,
        txt_size             = 9.5,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 28,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = '4',
        caption_weight       = 0.8,
        caption_size         = 8.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'c7'
    },
    {
        name                 = 'sysinfo',
        arg                  = 'cpu4',
        max_value            = w.dt.max_value,
        x                    = w.dt.cpu_x,
        y                    = w.dt.cpu_y,
        graph_radius         = w.dt.cpu_graph_radius - (w.dt.cpu_graph_radius_fact * 7),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.cpu_graph_radius - (w.dt.cpu_graph_radius_fact * 7),
        txt_weight           = 1,
        txt_on_base          = nil,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 28,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = '',
        caption_weight       = 0.8,
        caption_size         = 8.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'c8'
    },
---- Network rings
    {
        --conky_line         = '${if_up eth0}${downspeedf eth0}${else}${if_up wlan0}{downspeedf wlan0}${endif}${endif}',
        -- conky_line           = '${if_match "${addr eth0}" != "No Address"}${downspeedf eth0}${else}${if_match "${addr wlan0}" != "No Address"}${downspeedf wlan0}${endif}${endif}',
        -- conky_line           = '(1/${downspeedf eth0})*100',
        name                 = 'downspeedf',
        arg                  = 'eth0',
        max_value            = w.dt.max_value,
        x                    = w.dt.net_x,
        y                    = w.dt.net_y,
        -- graph_radius         = w.dt.net_graph_radius - (w.dt.net_graph_radius_fact * 2),
        graph_radius         = w.dt.net_graph_radius,
        -- graph_radius         = 60,
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.net_graph_radius,
        -- txt_radius           = 60,
        txt_weight           = 1.0,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 68,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = 'Down',
        caption_weight       = 0.8,
        caption_size         = 9.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'ds1'
    },
    {
        --conky_line='${if_up eth0}${upspeedf eth0}${else}${if_up wlan0}${upspeedf wlan0}${endif}${endif}',
        -- conky_line           = '${if_match "${addr eth0}" != "No Address"}${upspeedf eth0}${else}${if_match "${addr wlan0}" != "No Address"}${upspeedf wlan0}${endif}${endif}',
        name                 = 'upspeedf',
        arg                  = 'eth0',
        max_value            = w.dt.max_value,
        x                    = w.dt.net_x,
        y                    = w.dt.net_y,
        graph_radius         = w.dt.net_graph_radius - (w.dt.net_graph_radius_fact * 2),
        -- graph_radius         = 48,
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.net_graph_radius - (w.dt.net_graph_radius_fact * 2),
        -- txt_radius           = 48,
        txt_weight           = 1.0,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 56,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = 'Up',
        caption_weight       = 0.8,
        caption_size         = 9.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'up1'
    },
    {
        -- conky_line           = '${if_match "${addr wlan0}" != "No Address"}${wireless_link_qual_perc wlan0}${else}0${endif}',
        name                 = 'wireless_link_qual_perc',
        arg                  = 'wlan0',
        max_value            = w.dt.max_value,
        x                    = w.dt.net_x,
        y                    = w.dt.net_y,
        graph_radius         = w.dt.net_graph_radius - (w.dt.net_graph_radius_fact * 4),
        -- graph_radius         = 30,
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.net_graph_radius - (w.dt.net_graph_radius_fact * 4),
        -- txt_radius           = 30,
        txt_weight           = 1.0,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = w.dt.net_graph_radius - (w.dt.net_graph_radius_fact * 3.5),
        -- grad_radius          = 39,
        grad_length          = 4, -- grad-length
        grad_mark_thickness  = 2, -- grad-thickness
        grad_unit_angle      = 100/10,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = 'Signal',
        caption_weight       = 0.8,
        caption_size         = 9.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'wlan1'
    },
---- Memory + folder-size
    {
        name                 = 'memperc',
        arg                  = '',
        max_value            = w.dt.max_value,
        x                    = w.dt.mem_x,
        y                    = w.dt.mem_y,
        graph_radius         = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 0),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 0),
        txt_weight           = 1.0,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 30,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = 'memory',
        caption_weight       = 0.8,
        caption_size         = 9.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'mem1'
    },
    {
        name                 = 'fs_used_perc',
        arg                  = '/',
        -- name                 = 'folder-size',
        -- arg                  = '/home/param/Downloads',
        ---- The max_size is in kilobytes
        ---- values calculated by du are in kilobytes
        -- max_size             = 200*1024*1024,
        x                    = w.dt.mem_x,
        y                    = w.dt.mem_y,
        max_value            = w.dt.max_value,
        graph_radius         = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 1),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 1),
        txt_weight           = 1.0,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 30,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = 'root',
        caption_weight       = 0.8,
        caption_size         = 9.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'fs1'
    },
    {
        name                 = 'fs_used_perc',
        arg                  = '/home/param',
        -- name                 = 'folder-size',
        -- arg                  = '/home/param/Downloads',
        ---- The max_size is in kilobytes
        ---- values calculated by du are in kilobytes
        -- max_size             = 200*1024*1024,
        x                    = w.dt.mem_x,
        y                    = w.dt.mem_y,
        max_value            = w.dt.max_value,
        graph_radius         = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 2),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 2),
        txt_weight           = 1.0,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 30,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = 'home',
        caption_weight       = 0.8,
        caption_size         = 9.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'fs2'
    },
    {
        name                 = 'fs_used_perc',
        arg                  = '/home/param/disk5',
        -- name                 = 'forlder-size',
        -- arg                  = '/home/param/Downloads',
        ---- The max_size is in kilobytes
        ---- values calculated by du are in kilobytes
        -- max_size             = 200*1024*1024,
        x                    = w.dt.mem_x,
        y                    = w.dt.mem_y,
        max_value            = w.dt.max_value,
        graph_radius         = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 3),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 3),
        txt_weight           = 1.0,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 30,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = 'disk5',
        caption_weight       = 0.8,
        caption_size         = 9.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'fs3'
    },
    {
        name                 = 'fs_used_perc',
        arg                  = '/home/param/disk6',
        -- name                 = 'folder-size',
        -- arg                  = '/home/param/Downloads',
        ---- The max_size is in kilobytes
        ---- values calculated by du are in kilobytes
        -- max_size             = 200*1024*1024,
        x                    = w.dt.mem_x,
        y                    = w.dt.mem_y,
        max_value            = w.dt.max_value,
        graph_radius         = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 4),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 4),
        txt_weight           = 1.0,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 30,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = 'disk6',
        caption_weight       = 0.8,
        caption_size         = 9.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'fs4'
    },
    {
        name                 = 'fs_used_perc',
        arg                  = '/home/param/disk7',
        -- name                 = 'folder-size',
        -- arg                  = '/home/param/Downloads',
        ---- The max_size is in kilobytes
        ---- values calculated by du are in kilobytes
        -- max_size             = 200*1024*1024,
        x                    = w.dt.mem_x,
        y                    = w.dt.mem_y,
        max_value            = w.dt.max_value,
        graph_radius         = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 5),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 5),
        txt_weight           = 1.0,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 30,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = 'disk7',
        caption_weight       = 0.8,
        caption_size         = 9.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'fs5'
    },
    {
        name                 = 'fs_used_perc',
        arg                  = '/home/param/disk8',
        -- name                 = 'folder-size',
        -- arg                  = '/home/param/Downloads',
        ---- The max_size is in kilobytes
        ---- values calculated by du are in kilobytes
        -- max_size             = 200*1024*1024,
        x                    = w.dt.mem_x,
        y                    = w.dt.mem_y,
        max_value            = w.dt.max_value,
        graph_radius         = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 6),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 6),
        txt_weight           = 1.0,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 30,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = 'disk8',
        caption_weight       = 0.8,
        caption_size         = 9.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'fs6'
    },
    {
        name                 = 'fs_used_perc',
        arg                  = '/home/param/disk9',
        -- name                 = 'folder-size',
        -- arg                  = '/home/param/Downloads',
        ---- The max_size is in kilobytes
        ---- values calculated by du are in kilobytes
        -- max_size             = 100*1024*1024,
        x                    = w.dt.mem_x,
        y                    = w.dt.mem_y,
        max_value            = w.dt.max_value,
        graph_radius         = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 7),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 7),
        txt_weight           = 1.0,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 30,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = 'disk9',
        -- caption              = 'Downloads',
        caption_weight       = 0.8,
        caption_size         = 9.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'fs7'
    },
    {
        name                 = 'swapperc',
        arg                  = '',
        -- name                 = 'folder-size',
        -- arg                  = '/home/param/Downloads',
        ---- The max_size is in kilobytes
        ---- values calculated by du are in kilobytes
        -- max_size             = 200*1024*1024,
        x                    = w.dt.mem_x,
        y                    = w.dt.mem_y,
        max_value            = w.dt.max_value,
        graph_radius         = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 8),
        graph_thickness      = w.dt.graph_thickness,
        graph_start_angle    = w.dt.graph_start_angle,
        graph_unit_angle     = w.dt.graph_unit_angle,
        graph_unit_thickness = w.dt.graph_unit_thickness,
        graph_bg_colour      = w.dt.graph_bg_colour,
        graph_fg_colour      = w.dt.graph_fg_colour,
        hand_fg_colour       = w.dt.hand_fg_colour,
        txt_radius           = w.dt.mem_graph_radius - (w.dt.mem_graph_radius_fact * 8),
        txt_weight           = 1.0,
        txt_size             = 8.0,
        txt_fg_colour        = w.dt.txt_fg_colour,
        grad_radius          = 30,
        grad_length          = 0,
        grad_mark_thickness  = 1,
        grad_unit_angle      = 27,
        grad_fg_colour       = w.dt.grad_fg_colour,
        caption              = 's w a p',
        caption_weight       = 0.8,
        caption_size         = 9.0,
        caption_fg_colour    = w.dt.caption_fg_colour,
        id                   = 'fs8'
    },
}

return w
