#!/bin/bash
#
#   checkupdates: Safely print a list of pending updates.
#
#   Copyright (c) 2013-2015 Paramvir [ plikhari at gmail com
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

# to enable on systemd systems use cronie is part of the Arch base install
# sudo systemctl enable cronie.service
# to enable the cron job
# type sudo crontab -e and add following to run every 3 hours
# 0 */3 * * * /path_to_file/pacman_update.sh
# To see in the conky desktop:
# Place this line above the TEXT area with correct path
# template0 $WX_DIR/lib/conky_pacman_update.sh
# Place this line anywhere below the TEXT
# ${color3}Package Updates:${alignr}${color1}${execi 60 ${template0}}${font}


OIFS="$IFS"; IFS=$'\n'
	update_list=( $(pacman -Qu) )
IFS="$OIFS"

to_ignore=0
to_update=0

if [[ $update_list ]]; then
	to_update=${#update_list[@]}
	for d in ${!update_list[@]}
	do
		if [[ "${update_list[d]}" =~ '[ignored]' ]]; then
			(( to_ignore += 1 ))
			(( to_update -= 1 ))
		fi
	done
fi

case $to_update in
0)	echo "System up-to-date"                     ;;
*)	echo "$to_update new | $to_ignore ignored"   ;;
esac

