--[[
	Paramvir Likhari - conkywx 2011 - 2016 - GPL3
	common library for use with conkywx lua implementation
--]]

local tconcat = table.concat
local tonum   = tonumber

local function ScriptPath()
    local f1=io.popen('pwd')
    if f1 then
        local rinfo = f1:read("*a")
        f1:close()
        return rinfo:match( "^%s*(.-)%s*$" )
    end
end
package.path = tconcat({package.path,";",ScriptPath(),"/lib/?.lua;"})

local FC = require("luafunc")

local wxsplit          = FC.wxsplit
local ExecInfo         = FC.ExecInfo

local w        = {}

local pacupdate = 0
function w.pacman_update()
    --[[
        Copyright (c) 2013-2015 Paramvir

        to enable on systemd systems use cronie is part of the Arch base install
        sudo systemctl enable cronie.service
        to enable the cron job
        type sudo crontab -e and add following to run every 3 hours
        0 */3 * * * /path_to_file/cron_pacman_update.sh
        To see in the conky desktop:
        Place this text below in the TEXT / config.text area with correct path
        Pkgs: ${lua pacman_update}
    --]]

    local upd1 = tonum(conky_parse("${updates}"))
    if (upd1 % 60) == 0 or pacupdate == 0 then
        local pacdata   = {}
        local line      = ExecInfo({ cmd = 'pacman -Qu' })
        if line then pacdata = wxsplit(line,'\n') end
        local to_ignore = 0
        local to_update = 0

        if pacdata[1] and pacdata[1] ~= '' then
            to_update = #pacdata
            for d = 1, #pacdata do
                if pacdata[d]:find('%[ignored%]') then
                    to_ignore = to_ignore + 1
                    to_update = to_update - 1
                end
            end
        end

        if to_update == 0 then
            pacupdate = 'System up-to-date'
        else
            pacupdate = tconcat({to_update,' new | ',to_ignore,' ignored'})
        end
    end
    return pacupdate or ''
end

return w

