--[[
	Paramvir Likhari - conkywx 2011 - 2018 - GPL3
	pre_exec library for use with conkywx lua implementation
--]]

local tconcat = table.concat
local lmatch  = string.match
local lgsub   = string.gsub
local lcollectgarbage = collectgarbage

-- package.path = package.path .. ";./lib/?.lua;"

local FC = require("luafunc")

local wxsplit  = FC.wxsplit
local ExecInfo = FC.ExecInfo

local w, pretable = {}, {}
local counter = 0
local sNo

local cnTable, ts = {}, {}
local cn = 1
local function getCounter(infile)
    if not cnTable[infile] then
        cnTable[infile] = cn
        cn = cn + 1
    end
    for k, v in pairs(cnTable) do
        if k == infile then
            return v
        end
    end
end


function w.pre_exec(...)
    -- by paramvir 2017 conkywx
    local p = {...}
    local v1 = {}

    sNo = getCounter(p[1])
    counter = counter + 1


    if p[1] then
        local pdata = lmatch(tconcat(p,' '), '%s*(.*)%s*')
        local remdata = lmatch(pdata, '%-%-remove_text%s*(.*)')
        if remdata then
            pdata = lmatch(pdata, '(.*)%-%-remove_text')
        end

        if #pretable > 0 then
            for k = 1, #pretable do
                v1 = wxsplit(pretable[k],' ::: ')
                if v1[1] == pdata then
                    if remdata then
                        return lgsub(v1[2], remdata,'')
                    else
                        return v1[2]
                    end
                end
            end
        end
        if counter == sNo then
            pretable[#pretable + 1] = pdata
            for k = 1, #pretable do
                local pred = ExecInfo({ cmd = pretable[k] })
                pretable[k] = pretable[k] .. ' ::: ' .. (pred or '')
            end
        end
        return ''
    else
        error("\nError :(\npre_exec expects argument(s)")
    end
end

lcollectgarbage()

return w


