
--[[
    Paramvir Likhari - conkywx 2011 - 2017 - GPL3
--]]

local w = {}

local Global_Font_Size = 12
local TORADIANS        = 3.14159265358979323846/180

-- local next    = next
local labs    = math.abs
local lfloor  = math.floor
local tconcat = table.concat
local tinsert = table.insert
local supper  = string.upper
local tonum   = tonumber
local lsub    = string.sub
local lgsub   = string.gsub
local lfind   = string.find
local lmatch  = string.match
local lrep    = string.rep

local lcollectgarbage = collectgarbage

local Yellow  = 0xFFFF00
local Orchid1 = 0xFF83FA

local lcairo_save            = cairo_save
local lcairo_restore         = cairo_restore
local lcairo_set_source_rgba = cairo_set_source_rgba
local lcairo_text_extents    = cairo_text_extents

local lconky_window = conky_window
local lconky_info   = conky_info
local lconky_parse  = conky_parse

-- local myPackage = package
-- myPackage.path = myPackage.path .. "./lib/?.lua;"

local FC          = require("luafunc")

local wxsplit     = FC.wxsplit
local to_rgba     = FC.to_rgba
local set_font    = FC.set_font
local make_txt    = FC.make_txt
local ExecInfo    = FC.ExecInfo
local background  = FC.background
local tableLength = FC.tableLength
local FileExists  = FC.FileExists
local msgout      = FC.msgout

-- local function set_font(p)
--     if not Global_Font_Size then
--         Global_Font_Size = do_set_font(p) or 12
--     end
--     do_set_font(p)
-- end

local cstat,ostat,rdata = {},{},{}
-- local labelName, labelColour
local timer = 0
function w.scroller(p)
    -- by paramvir 2014
    local cr          = p.cr
    local lpx         = p.lwx   or 50
    local lpy         = p.lwy   or 250          -- p
    local align_text  = p.a     or 'l'
    local showBlock   = p.b     or 0
    local sccolour    = p.c     or '0x00c0ff:1'
    local mdata       = p.d     or nil
    local fontSize    = p.f     or 12
    local alt_h_light = p.g     or tconcat({Orchid1,':1'})
    local h_light     = p.h     or tconcat({Yellow,':1'})
    local jumpinc     = p.i     or 10           -- v
    local label       = p.j     or nil
    local vspace      = p.k     or 0
    local grplen      = p.l     or 36 -- text length l
    local inFile      = p.o     or nil
    local range       = p.r     or 0        -- r
    local stepval1    = p.s     or 1  -- text stepping s
    local drc         = p.w     or "B"     -- d
    local mcolour     = wxsplit(sccolour,":")

    lcairo_set_source_rgba(cr,to_rgba(mcolour))
    drc = supper(drc)

    lcairo_save(cr)
    set_font({ cr, fontSize })
    lcairo_restore(cr)
    -- local extents = cairo_text_extents_t:create()
    -- tolua.takeownership(extents)

    local updates1 = tonum(lconky_parse("${updates}"))
    local updates = 1
    local updateInterval = 10
    if lconky_info.update_interval < 1 then
        if updates1 % updateInterval == 0 then
            updates = updates1 / updateInterval
        end
    else
        updates = updates1
    end
    local f_check = updates % 2

    if mdata then mdata = lgsub(p.d,":::","| ") end

    if tonum(showBlock) then
        showBlock = tonum(showBlock)
        bgcolour  = nil
    elseif lmatch(showBlock,'::') then
        local shblk = wxsplit(showBlock,'::')
        showBlock   = tonum(shblk[1])
        bgcolour    = shblk[2]
    end


    local labelName, labelColour
    if inFile and FileExists(inFile) then
        ostat[inFile] = ExecInfo({ cmd = [[stat -c %Z ]] .. inFile })
        if not cstat[inFile] or cstat[inFile] ~= ostat[inFile] then
            local idata = ExecInfo({ rfile = inFile })
            if idata then
                if showBlock >= 1 then
                    rdata[inFile] = wxsplit(idata,'\n')
                    local labelTable = {}
                    if label then
                        if lmatch(label,':') then
                            labelTable = wxsplit(label,':')
                            labelName  = labelTable[1]
                        end
                        tinsert(rdata[inFile],1,labelName)
                    end
                else
                    rdata[inFile] = lgsub(idata,"\n", " | ")
                    if lmatch(idata,'|') then rdata[inFile] = rdata[inFile] .. ' <:> ' end
                end
            end
        end
        cstat[inFile] = ostat[inFile]
    else
        error("\n\nError :( data file \"".. inFile .."\" not found.\n")
    end

    if label then
        if lmatch(label,':') then
            labelTable = wxsplit(label,':')
            labelName  = labelTable[1]
            for x = 1, #labelTable do
                if lmatch(labelTable[x],'0x') then
                    labelColour = labelTable[x]
                    break
                end
            end
            labelColour = labelColour or '0xFFAA00'
        end
    end

    local ww = lconky_window.width
    local wh = lconky_window.height
    if lpy > wh then lpy = wh
    elseif lpy < 0 then lpy = 0
    end

    local lineposn = lpy

    if showBlock == 0 then
        local stepval = labs(stepval1)
        if mdata then rdata[inFile] = mdata end
        -- rdata[inFile] = '  '..rdata[inFile]
        local txtlen  = #rdata[inFile]

        local gettxt1, gettxt2
        timer = (((updates * 3) % txtlen) + 1)
        local sv    = stepval + 3

        if txtlen > grplen then
            for i=1,txtlen do
                local gettxt1 = lrep(rdata[inFile]..' | ',sv)
                -- print(gettxt1)
                if timer == i then
                    local l=i*stepval
                    if stepval1 > 0 then
                        local gettxt2 = lsub(gettxt1,l)
                        w.gettxt3     = lsub(gettxt2,1,grplen)
                    elseif stepval1 < 0 then
                        local gettxt2 = lsub(gettxt1,-#gettxt1,-l)
                        w.gettxt3     = lsub(gettxt2,-grplen,-1)
                    end
                end
                gettxt1 = " "
            end
            local srange = range/2
            local minrange = lpy-srange
            if minrange <= 0 then minrange = 10; range = srange + lpy end
            local maxrange = lpy+srange
            if maxrange >= wh then
                maxrange=(wh-jumpinc);
                range = srange+((lpy+srange+jumpinc)-wh)
            end
            local startpt = maxrange

            local timerval = (lfloor(range/jumpinc)-1)
            if timerval == 0 then timerval = 1 end
            local timer2 = ((updates % timerval) + 1)
            local l = 0
            if range > 0 then
                if range > l then l = range end
                for i=1, wh do
                    if l > 0 then
                        if timer2 == i then
                            l=i*jumpinc
                            if drc=="B" then
                                if i == 1 and j==1 or j==nil then
                                    j=2
                                elseif i == 1 and j==2 then
                                    j=1
                                end
                                if j == 1 then startpt=minrange+l --- down
                                elseif j == 2 then startpt=(maxrange+jumpinc)-l  --- up
                                end
                            elseif drc=="U" then
                                startpt=(maxrange+jumpinc)-l  --- up
                            elseif drc=="D" then
                                startpt=minrange+l --- down
                            end
                            if startpt < minrange then startpt = minrange
                            elseif startpt > maxrange then startpt = maxrange end
                        end
                    end
                    lineposn = startpt or lpy
                end
            end
        else
            w.gettxt3 = rdata[inFile]
        end
        local extents = cairo_text_extents_t:create()
        tolua.takeownership(extents)

        lcairo_save(cr)
        local mkData = {
            cr      = cr,
            text    = w.gettxt3,
            px      = lpx,
            py      = lineposn,
            align   = align_text,
            icolour = mcolour,
            ext     = extents,
        }
        make_txt(mkData)
        lcairo_restore(cr)
    else
    -- elseif showBlock >= 1 then
        local inum, mtxt, i, tmptxt, txtlen, extents
        inum = 1
        -- msgout(rdata[inFile][3])
        tmptxt = rdata[inFile][3]
        extents = cairo_text_extents_t:create()
        tolua.takeownership(extents)
        lcairo_text_extents(cr, tmptxt, extents)
        tmptxt = nil

        txtlen = #rdata[inFile]
        if txtlen and txtlen > 0 then
            -- set background and widget position
            if showBlock == 3 or showBlock == 4 then
                local text_block_ht = ((Global_Font_Size + vspace) * txtlen) + Global_Font_Size
                local winy = lconky_window.height
                if showBlock == 3 then
                    lineposn = winy - text_block_ht - p.lwy - 2
                else
                    lineposn = lconky_window.text_start_y + 12
                end
                local bgsize = tconcat({extents.width + Global_Font_Size + 3, ',', text_block_ht})
                local bgposn = tconcat({lpx - 4, ',', lineposn - 2})
                local bgData = {
                    cr = cr,
                    r  = 10,
                    c  = bgcolour or '0x333333:0.6',
                    s  = bgsize,
                    p  = bgposn,
                }
                background(bgData)
            end

            for i = 1, txtlen do
                mtxt = nil
                if i == 1 then
                    mtxt  = rdata[inFile][i]
                end
                if lmatch(rdata[inFile][i],'day') then
                    mtxt  = rdata[inFile][i]
                    inum = 0
                else
                    if showBlock == 2 then
                        inum = inum + 1
                        if inum == 1 or inum == 3 then
                            if  rdata[inFile][i+1] and
                                not lmatch(rdata[inFile][i+1],'day') then
                                mtxt  = rdata[inFile][i] .. " " .. rdata[inFile][i+1]
                            else
                                mtxt  = rdata[inFile][i]
                            end
                        end
                    else
                        mtxt  = rdata[inFile][i]
                    end
                end

                local style
                if h_light and h_light ~= '0' and mtxt then
                    mcolour = nil
                    if lfind(mtxt,'@',1,true) then
                        if f_check == 0 then
                            mcolour = wxsplit(h_light,":")
                            mcolour = {mcolour[1],0.45}
                            style = fontSize..':0'
                        else
                            style = fontSize..':1'
                            mcolour = wxsplit(h_light,":")
                        end
                        mtxt = lgsub(mtxt,'%@%*','*')
                        mtxt = lgsub(mtxt,'%@',' ')
                    elseif lfind(mtxt,'>',1,true) then
                        mcolour = wxsplit(h_light,":")
                        style = fontSize..':1'
                    elseif lfind(mtxt,'*',1,true) then
                        mcolour = wxsplit(alt_h_light,":")
                        style = fontSize..':1'
                    elseif not mcolour then
                        mcolour = wxsplit(sccolour,":")
                        style = nil
                    end
                end
                if mtxt == labelName then
                    style = label
                    mcolour = {labelColour,1}
                else
                    if not style then style = fontSize end
                end
                lcairo_save(cr)
                if mtxt then
                    -- msgout(mtxt)
                    lineposn = lineposn + Global_Font_Size + vspace
                    local mkData = {
                        cr      = cr,
                        text    = mtxt,
                        px      = lpx,
                        py      = lineposn,
                        align   = align_text,
                        icolour = mcolour,
                        style   = style,
                        ext     = extents,
                    }
                    make_txt(mkData)
                end
                lcairo_restore(cr)
            end
        end
    end
end

lcollectgarbage()

return w
