
--[[
    Paramvir Likhari - conkywx 2011 - 2016 - GPL3
    bargraph library for use with conkywx lua implementation
--]]

local w = { true }

local Global_Font_Size
local PI        = 3.14159265358979323846
local TORADIANS = 3.14159265358979323846/180
local TODEGREES = 180/3.14159265358979323846
local tconcat   = table.concat
local tonum     = tonumber
local random    = math.random
local sin       = math.sin
local abs       = math.abs
local atan2     = math.atan2
local supper    = string.upper
local lmatch    = string.match

local lcollectgarbage = collectgarbage

local lcairo_move_to         = cairo_move_to
local lcairo_line_to         = cairo_line_to
local lcairo_rotate          = cairo_rotate
local lcairo_show_text       = cairo_show_text
local lcairo_stroke          = cairo_stroke
local lcairo_stroke_preserve = cairo_stroke_preserve
local lcairo_fill            = cairo_fill
local lcairo_fill_preserve   = cairo_fill_preserve
local lcairo_save            = cairo_save
local lcairo_restore         = cairo_restore
local lcairo_set_source_rgba = cairo_set_source_rgba
local lcairo_arc             = cairo_arc
local lcairo_close_path      = cairo_close_path
local lcairo_set_line_width  = cairo_set_line_width
local lcairo_text_extents    = cairo_text_extents


local Red          = 0xFF0000
local RoyalBlue    = 0x4169E1
local MidnightBlue = 0x191970
local Black        = 0x000000
local Orchid1      = 0xFF83FA
local Gold         = 0xFFD700
local Lime         = 0x00FF00


-- package.path = package.path .. ";./lib/?.lua;"

local FC = require("luafunc")
local wxsplit          = FC.wxsplit
local to_rgba          = FC.to_rgba
local get_points       = FC.get_points
local do_set_font      = FC.set_font
local make_scale_txt2  = FC.make_scale_txt2
local make_bezel       = FC.make_bezel
local choose_indicator = FC.choose_indicator
local put_image        = FC.put_image
local instrument_sqr   = FC.instrument_sqr
local FileExists       = FC.FileExists
local msgout           = FC.msgout
local ExecInfo         = FC.ExecInfo

local function set_font(p)
    Global_Font_Size = do_set_font(p) or 12
end

----------------------------------------------------------------------
-- local wvlastVal, slim, slim_step, star_step
local wvlastVal
local h,i,updates = 0,1,0

local function windvane(p)


    local cr          = p.cr
    local wx          = p.lwx
    local wy          = p.lwy
    local rout        = (p.s*0.52)
    local wdeg        = p.d or "NA"
    local wspeed      = p.e or "NA"
    local file1       = p.i or "NA"
    local wv_arrow    = p.a or 3
    local bimage1     = p.j or 0
    local acolour     = p.l or Red..':1'
    local bcolour     = p.b or MidnightBlue..':0.7'
    local rcolour     = p.r or Gold..':1'
    local scolour     = p.o or RoyalBlue..':1'
    local tcolour     = p.c or Lime..':1'
    local nring       = p.nring or nil
    local star_style  = p.y or 5
    local star_sizet  = p.z or "l"
    local stroke_fill = p.x or "s"
    local wvpath      = p.imgpath
    local updates1    = p.info
    local tilt        = p.t

    local x_image_corr = 0
    local y_image_corr = 0

    -- updates = tonum(conky_parse("${updates}"))
    if updates == 9 then updates = 0 end
    updates = updates + 1
    -- print(updates)

    local random_seed = 0

    acolour = wxsplit(acolour,":")
    bcolour = wxsplit(bcolour,":")
    rcolour = wxsplit(rcolour,":")
    scolour = wxsplit(scolour,":")
    tcolour = wxsplit(tcolour,":")

    -- msgout('bimage1=',bimage1)
    local bimageT = {}
    -- if not tonum(bimage1) and bimage1:match(':') then
        bimageT  = wxsplit(bimage1,':')
    -- end
    local bimage   = bimageT[1] or bimage1
    local bezStyle = {2, bimageT[2] or 1, bimageT[3] or 2.5}

    if not bimage and file1 ~= "NA" then
        routI = p.s * 0.01
        rout  = p.s * 0.52
    elseif tonum(bimage) == 1 then
        routI = p.s * 0.0091
        rout  = p.s * 0.45
    elseif tonum(bimage) == 2 then
        routI = p.s * 0.009174
        rout  = p.s * 0.45
    else
        routI = p.s * 0.0091
        rout  = p.s * 0.45
    end

    if not nring then
        wx = p.lwx+(p.s*0.5)+5
        wy = p.lwy+(p.s*0.5)
    else
        wx = p.lwx
        wy = p.lwy
    end

    -- wdeg=180
    -- print(wdeg)
    local variance
    if conky_info.update_interval < 5 then
        variance = ( updates % 4 ) + 1
    else
        variance = 1
    end

    if  wdeg         and
        wdeg ~="NA"  and
        wdeg ~="Var" then
        wdeg = tonum(wdeg)
    end
    if  wdeg and type(wdeg) == "number" then
        if variance == 1 then
            local wdir_variance = 9
            wdeg = wdeg + random(-wdir_variance,wdir_variance)
            wvlastVal = wdeg
            --print(variance,updates, wdeg)
        else
            wdeg = wvlastVal
            -- wvlastVal = nil
        end
        -- wdeg = wdeg
    elseif wdeg == "Var" then
        local wvar1 = (( updates % 5) + 1)
        if wvar1 == 1 then
            wdeg = random(0,360)
            wvlastVal = wdeg
        else
            wdeg = wvlastVal
            -- wvlastVal = nil
        end
    end
    -- wdeg=90
    local extents = cairo_text_extents_t:create()
    tolua.takeownership(extents)

    if file1 == "NA" or file1 == "0" then

        if tonum(bimage) == 2 then
            lcairo_save(cr)
            local mB = { cr = cr, bezel_size = p.s*0.95, px = wx, py = wy,tilt=tilt,style=bezStyle }
            make_bezel(mB)
            lcairo_restore(cr)
            -- nring = nil
        end
        -- ring for cardinal points
        -- lcairo_set_source_rgba(cr, to_rgba(ring_bground))
        lcairo_set_source_rgba(cr, to_rgba(bcolour))
        lcairo_arc(cr,wx,wy,rout,TORADIANS,0)
        lcairo_fill(cr)
        ------------------------------------
        local star_size
        if supper(star_sizet) == "L" then
            star_size=96
        else
            star_size=50
        end

        local slim, slim_step, star_step
        local slimT = { 0, 11.25, 22.5, 45, 67.5, 90 }
        local starT = { 11.25, 22.5, 45, 90 }
        -- local star_colour={0x00fff9,1}
        local line_thickness=1
        -- local stroke_fill="f"
        if star_style then
            if supper(star_style) == "D" then
                wvtimer=((updates%1)+1)
                for j=0,100 do
                    if wvtimer == j then
                        j = j * 10
                        if not slim_step then slim_step = slimT[1] end
                        if not star_step then star_step = starT[1] end
                        if not slim      then slim      = j*10     end

                        if     slim== 100 and slim_step==90 and star_step==90 then slim=-j
                        elseif slim==-100 and slim_step==90 and star_step==90 then slim=j
                        elseif slim > 0   and slim_step<=90 and star_step<=90 then slim=j
                        elseif slim < 0   and slim_step<=90 and star_step<=90 then slim=-j
                        end

                        if abs(slim) == 10 then h = h + 1 end
                        if h == (#slimT + 1) then h = 1; i = i + 1 end
                        if i == (#starT + 1) then i = 1 end
                        slim_step = slimT[h]
                        star_step = starT[i]
                        lastval   = slim
                        print(tconcat({slim,":",slim_step,":",star_step}))
                    else
                        slim=lastval
                    end
                end
            elseif type(star_style) ~= "number" and star_style:match(":") then
                local sst = wxsplit(star_style,":")
                -- print(sst[1],sst[2],sst[3])
                local starmsg = 'Star style requires 3 arguments'
                slim      = sst[1] or print(starmsg)
                slim_step = sst[2] or print(starmsg)
                star_step = sst[3] or print(starmsg)
            else
                local sst1 = tonum(star_style)
                local sstyle = {
                    [1] = {slim=15 , slim_step=22.5 , star_step=45  },
                    [2] = {slim=20 , slim_step=11.25, star_step=22.5},
                    [3] = {slim=100, slim_step=22.5 , star_step=22.5},
                    [4] = {slim=100, slim_step=90   , star_step=45  },
                    [5] = {slim=100, slim_step=45   , star_step=45  },
                }
                if sst1 > 5 then sst1 = 5 end
                slim      = sstyle[sst1].slim
                slim_step = sstyle[sst1].slim_step
                star_step = sstyle[sst1].star_step
            end

            for i=0,360,star_step do
                local rout2     = (rout*(star_size*0.01))
                local pxa1,pya1 = get_points(0,i,slim_step,rout2*(slim*0.01))
                local pxa2,pya2 = get_points(0,i,star_step,-rout2*1)
                lcairo_line_to(cr, wx+pxa1, wy+pya1)
                lcairo_line_to(cr, wx+pxa2, wy+pya2)
            end
            lcairo_close_path(cr)
            lcairo_set_source_rgba(cr, to_rgba(scolour))
            lcairo_set_line_width(cr,line_thickness)
            if not stroke_fill then lcairo_stroke(cr)
            elseif supper(stroke_fill) == "S" then lcairo_stroke(cr)
            elseif supper(stroke_fill) == "F" then lcairo_fill(cr)
            else lcairo_stroke(cr)
            end
        end

        ---------------------------------}}}
        -- lcairo_set_source_rgba(cr, to_rgba(rcolour))
        if tonum(bimage) ~= 2 then
            if nring then
                lcairo_set_source_rgba(cr, to_rgba(bcolour))
                lcairo_set_line_width(cr,1)
                lcairo_arc(cr,wx,wy,rout,TORADIANS,0)
            else
                lcairo_set_source_rgba(cr, to_rgba(rcolour))
                lcairo_arc(cr,wx,wy,rout,TORADIANS,0)
            end
            lcairo_stroke(cr)
        end

        lcairo_set_source_rgba(cr, to_rgba(rcolour))
        lcairo_set_line_width(cr,1)
        for i=1,36 do
            lcairo_save(cr)
            local msTable = {
                cr            = cr,
                startscale    = 0,
                endscale      = 10,
                maxscale      = 1,
                lineLength    = rout * 0.1,
                lineThickness = 3,
                rin           = rout * 0.93,
                xval          = wx,
                yval          = wy,
                i             = i,
            }
            make_scale_txt2(msTable)
        end
        --print cardinal directions
        -- local font="Mono"
        local fsize=(rout/5)
        if fsize < 8 then fsize = 8 end
        lcairo_save(cr)
        -- set_font({ cr, "Mono:fsize"])
        set_font({ cr, "Mono:fsize:bold" })
        local dirs = {true, true, true, true, true, true, true, true}
        if rout < 35 then dirs={"N","E","S","W"}
        else dirs={"N","NE","E","SE","S","SW","W","NW"} end
        local rdir=rout-((rout/100)*32)
        for i=1,#dirs do
            local msTable = {
                cr         = cr,
                startscale = 0,
                endscale   = 360,
                maxscale   = #dirs,
                trout      = rdir,
                ext        = extents,
                dotext     = 1,
                text       = dirs[i],
                xval       = wx,
                yval       = wy,
                i          = i-1,
            }
            make_scale_txt2(msTable)
        end
    else
        local fileN
        if tonum(file1) then
            fileN = tconcat({wvpath,"/lua_windvane/windvane-",file1,".png"})
        else
            fileN = file1
        end
        if FileExists(fileN) then
            if tonum(bimage) == 2 then
                lcairo_save(cr)
                --make_bezel({ cr = cr, bezel_size = p.s*1.035, px = wx, py = wy })
                local mB = { cr = cr, bezel_size = p.s*0.95, px = wx, py = wy,tilt=tilt,style=bezStyle }
                make_bezel(mB)
                lcairo_restore(cr)
                local piData = {cr=cr,x=wx+(x_image_corr or 0), y=wy+(y_image_corr or 0), file=fileN, scale=routI}
                put_image(piData)
            else
                local piData = {cr=cr,x=wx+(x_image_corr or 0), y=wy+(y_image_corr or 0), file=fileN, scale=routI}
                put_image(piData)
            end
        end
    end

    -- indicator arrow
    local npr=rout-(rout*0.15)

    if wdeg=="NA" then
        -- local font1="Mono"
        if not nring then
            --fsize1=(rout/2.657778)
            fsize1=(rout*0.376254149143)
        else
            --fsize1=(rout/3.43)
            fsize1=(rout*0.2915451895)
            -- print(rout)
        end

        if wspeed == "Calm" then
        -- if type(wspeed) == 'string' then
            wdeg = wspeed
            lcairo_set_source_rgba(cr, to_rgba(tcolour))
        else
            lcairo_set_source_rgba(cr, to_rgba(acolour))
        end
        lcairo_save(cr)
        set_font({ cr, "Mono:" .. fsize1 .. ":bold" })
        local extents = cairo_text_extents_t:create()
        tolua.takeownership(extents)

        lcairo_text_extents(cr, wdeg, extents)
        lcairo_move_to(cr, wx - extents.width * 0.5, wy + extents.height * 0.5)
        lcairo_show_text(cr, wdeg)
        lcairo_stroke(cr)
    else
        -- if wv_arrow or wv_arrow ~= "NA" then
        -- if tonum(wv_arrow) then
            -- wv_arrow = tonum(wv_arrow)
            -- wv_arrow = 3
            local arrow
            if wv_arrow ~= 1 and wdeg then wdeg = wdeg + 180 end
            if wv_arrow > 10 and wv_arrow < 50 then
                arrow = wv_arrow
                wv_arrow = 11
            else
                arrow = wv_arrow
            end

        -- Let Lua draw the compass arrow -- }}}
        lcairo_save(cr)
        --local ind_length=rout-((rout/100)*15)
        local ind_length = rout-(rout*0.15)
        local thickness  = rout-(rout*0.88)
        if wdeg==nil then wdeg=0 end
        local ciData = {
            cr      = cr,
            startval= 0,
            range   = 360,
            scale   = wdeg,
            rout1   = ind_length,
            rin3    = thickness,
            px      = wx,
            py      = wy,
            arrow   = arrow,
            ch_indi = wv_arrow,
            icolour = acolour,
            ip      = wvpath,
        }
        choose_indicator(ciData)
    end -- indicator arrow end
    if tonum(bimage) == 1 then
        lcairo_save(cr)
        local isData = { cr = cr, routI=p.s, wx=wx-1-(p.s*0.5), wy=wy-1-(p.s*0.5)}
        instrument_sqr(isData)
        lcairo_restore(cr)
    end

    -- lcairo_destroy(cr)

end --compass end


----------------------------------------------------------------------
function w.showcond(p)

    local cr        = p.cr
    local wx        = p.lwx+(p.s*0.5)
    local wy        = p.lwy+(p.s*0.5)
    local rout      = p.s or 100
    local wdeg      = tonum(p.d) or ' '
    local fileA     = p.i           or "NA"
    local bimage1   = p.j           or 0
    local tilt      = p.t           or nil
    local Ctype     = p.f           or "-"
    local show_what = supper(p.w) -- Cond / Wind / Moon
    local showthick = p.v
    local sccolour  = p.c           or tconcat({Lime,":1"})

    local bimageT  = wxsplit(bimage1,':')
    local bimage   = bimageT[1] or nil
    local bezStyle = {2, bimageT[2] or 1,bimageT[3] or 2.5}

    local mcolour = wxsplit(sccolour,":")

    if     show_what == 'CF' then font1 = 'ConkyWeather'
    elseif show_what == 'WF' then font1 = 'ConkyWindNESW'
    elseif show_what == 'MF' then font1 = 'Moon Phases'
    end

    if Ctype == '\\#' then Ctype = "#" end --character type

    local compare = { CF = true, WF = true, MF = true }

    -- if show_what == "CF" or show_what == "WF" or show_what == "MF" then
    if compare[show_what] then
        if tonum(bimage) == 2 then
            lcairo_save(cr)
            local mB = { cr = cr, bezel_size = rout*0.95, px = wx+5, py = wy,tilt=tilt,style=bezStyle }
            make_bezel(mB)
            lcairo_restore(cr)
        end
        local fsize1=p.s
        lcairo_save(cr)
        -- local ftype
        local nOrb
        if showthick == 1 then
            if show_what == "CF" then
                nOrb = ':bold'
            else
                nOrb = ':normal'
            end
        else
            nOrb = ':normal'
        end
        set_font({ cr, tconcat({font1,":",fsize1,nOrb}) })
        local text1    = Ctype
        local extents  = cairo_text_extents_t:create()
        tolua.takeownership(extents)
        lcairo_text_extents(cr, text1, extents)
        local fx = p.lwx + 5
        local fy = p.lwy + (rout * 0.095) + extents.height
        if showthick == 1 then
            lcairo_set_source_rgba(cr, to_rgba({Black,0.35}))
            lcairo_move_to(cr,fx+(rout*.020),fy+(rout*.020))
            lcairo_show_text(cr,text1)
            lcairo_set_source_rgba(cr, to_rgba(mcolour))
            lcairo_move_to(cr,fx,fy)
            lcairo_show_text(cr,text1)
            lcairo_move_to(cr,fx+0.5,fy+0.5)
            lcairo_show_text(cr,text1)
            lcairo_stroke(cr)
            lcairo_save(cr)
            if show_what ~= "MF" then
                set_font({ cr, tconcat({font1,":",fsize1,":normal"}) })
                lcairo_set_source_rgba(cr, to_rgba({Black,0.4}))
                lcairo_move_to(cr,fx+(rout*.015),fy+(rout*.015))
                lcairo_show_text(cr,text1)
            end
        else
            lcairo_set_source_rgba(cr, to_rgba(mcolour))
            lcairo_move_to(cr,fx,fy)
            lcairo_show_text(cr,text1)
        end
        lcairo_stroke(cr)

        if tonum(bimage) == 1 then
            lcairo_save(cr)
            local isData = { cr = cr, routI=rout, wx=wx+5, wy=wy}
            instrument_sqr(isData)
            lcairo_restore(cr)
        end
    else
        wx = wx; wy = wy+1
        if show_what == "CI" then
            if FileExists(fileA) then
                lcairo_move_to(cr,wx,wy)
                -- local scale = rout * 0.01
                local scale = rout / 108
                if tonum(bimage) == 1 or tonum(bimage) == 2 then
                    scale = rout * 0.00908
                end
                if tonum(bimage) == 2 then
                    lcairo_save(cr)
                    local mB = { cr = cr, bezel_size = rout*0.95, px = wx+1, py = wy,tilt=tilt,style=bezStyle }
                    make_bezel(mB)
                    lcairo_restore(cr)
                    wx = wx+0.5; wy = wy+0.5
                end

                local piData = {cr = cr, x = wx, y = wy, file=fileA, scale = scale }
                put_image(piData)

                if tonum(bimage) == 1 then
                    lcairo_save(cr)
                    local isData = { cr = cr, routI = rout, wx = p.lwx, wy = p.lwy }
                    instrument_sqr(isData)
                    lcairo_restore(cr)
                end
            end
        elseif show_what == "MI" then
            local rotAng = tonum(ExecInfo({cmd = [[ head -n 1 ~/.config/conkywx/conkywx_internal/wxdnmoon ]] }))

            if not rotAng then
                -- work out moon orientation
                local DN = require("daynight")
                local daynight = DN.daynight
                daynight({ cr = cr, s = 300, lwx = -60, lwy = 590 })
                rotAng = tonum(ExecInfo({cmd = [[ head -n 1 ~/.config/conkywx/conkywx_internal/wxdnmoon ]] }))
            end

            local moonImageNumber = tonum(lmatch(fileA,'.*%/(.-)%.png')) or 0
            if moonImageNumber == 15 or moonImageNumber == 30 then
                rotAng = 0
            elseif moonImageNumber < 4 then
                rotAng = -135 + rotAng
            elseif moonImageNumber > 26 then
                rotAng = 135 + rotAng
            elseif moonImageNumber < 15 then
                rotAng = -135 + rotAng
            elseif moonImageNumber > 15 then
                rotAng = 135 + rotAng
            end

            -- local arc = TORADIANS * wdeg
            local arc = TORADIANS * rotAng
            if FileExists(fileA) then
                lcairo_move_to(cr,wx,wy)
                local scale = rout / 108
                wx = wx+0.5; wy = wy+0.5
                if tonum(bimage) == 2 then
                    lcairo_save(cr)
                    local mB = { cr = cr, bezel_size = rout*.95, px = wx, py = wy,tilt=tilt,style=bezStyle }
                    make_bezel(mB)
                    lcairo_restore(cr)
                    wx = wx-0.3; wy = wy-0.3; scale = rout * 0.00908
                end

                local piData = {cr=cr,x=wx, y=wy, file=fileA, scale=scale, theta=arc, rotate=true}
                put_image(piData)

                if tonum(bimage) == 1 then
                    lcairo_save(cr)
                    local isData = { cr = cr, routI=rout, wx=p.lwx, wy=p.lwy}
                    instrument_sqr(isData)
                    lcairo_restore(cr)
                end
            end
        elseif show_what == "WI" then
            local w_vane = {
                cr      = p.cr,
                lwx     = p.lwx - 4.5,
                lwy     = p.lwy,
                s       = p.s,
                t       = p.t,
                d       = p.d,
                e       = p.e,
                i       = p.i,
                a       = p.a,
                j       = p.j,
                l       = p.l,
                b       = p.b,
                r       = p.r,
                o       = p.o,
                c       = p.c,
                y       = p.y,
                z       = p.z,
                x       = p.x,
                imgpath = p.imgpath,
                nring   = p.nring,
            }
            windvane(w_vane)
            -- print(p.d)
        end
    end
    -- print('02-------------------\n',show_what,collectgarbage("count"))

end --showcond end

lcollectgarbage()

return w
