
--[[
    Paramvir Likhari - conkywx 2011 - 2018 - GPL3
    better image display with transparency
--]]

local w = { true }

local lcollectgarbage = collectgarbage

local FC = require("luafunc")
local background       = FC.background
local FileExists       = FC.FileExists
local msgout           = FC.msgout
local ExecInfo           = FC.ExecInfo

local OS = require('os')
local lexecute = OS.execute
local lremove  = OS.remove

local ST = require('string')
local lmatch    = ST.match
local lgsub     = ST.gsub

local TB = require('table')
local tconcat   = TB.concat

local ts = {}
local sNo

local cnTable = {}
local cn = 1
local function getCounter(infile)
    if not cnTable[infile] then
        cnTable[infile] = cn
        cn = cn + 1
    end
    for k, v in pairs(cnTable) do
        if k == infile then
            return v
        end
    end
end

----------------------------------------------------------------------
function w.showimage(p)

    sNo = getCounter(p.i)
    local tc = { [sNo] = sNo }
    if not ts[tc[sNo]] then ts[tc[sNo]] = 0 end
    ts[tc[sNo]] = ts[tc[sNo]] + 1

    local cr = p.cr
    if FileExists(p.i) then

        local temppath = lmatch(p.i,'(.-)([^%/]-([^%.]+))$')
        local pngFile  = lgsub(p.i,'(.+%/.+)%..-$','%1.png',1)

        local loadingFile  = temppath .. 'loading'
        local showimagetmp = temppath .. 'showimage.tmp'
        -- local anyPng = temppath .. '*.png'

        if FileExists( loadingFile ) then
            lexecute( [[touch ]] .. showimagetmp )
        end

        if FileExists(showimagetmp) and
            not FileExists(loadingFile) or
            ts[tc[sNo]] == 3 then

            lremove(showimagetmp)
            lremove(pngFile)
        end

        if ExecInfo({ cmd = [[ type -p convert ]] }) ~= '' and
            not FileExists(pngFile) then

            lexecute(tconcat({[[convert -matte -channel A +level 0,]], (p.a or 100), [[% +channel ]], p.i," ", pngFile, [[ 2> /dev/null ]]  }))
            -- lexecute(tconcat({[[convert -matte -channel A +level 0,]], (p.a or 100), [[% +channel -resize 760x600\! ]], p.i," ", pngFile, [[ 2> /dev/null ]]  }))

        end

        background({
            cr = cr,
            r  = 0,
            c  = '0x000000:0',
            i  = pngFile,
            e  = p.e,
            s  = p.s,
            p  = p.p,
            b  = p.b,
        })
    else
        return nil
    end

end

lcollectgarbage()

return w
