package tides;

=comments
    Parses tides
    This version (c) 2019 Paramvir Likhari
=cut

$tides::VERSION = '9';

require Exporter;
@tides::ISA = qw(Exporter);
@tides::EXPORT = qw(doTides); # function to export

use strict;
use warnings;


sub msgout  { print STDERR "@_ \n" }

## any reference to functions in the main program can be called like main::calltofunction()

sub doTides {

    my ( $temppath, $tForm, $noFileMsg, $ttime, ${year}, $yday,$tide_data, $tide_days_opt, $tide_days_num, $tide_date, $tide_date_format ) = @_ ;

    my ( @tset, $cnt,  ) ;

    my %tdhl  = ( "High Tide" => "HT", "Low Tide"  => "LT" );
    # my$tForm = $timeFormat{$conf{Time_format}} // $conf{Time_format} ;

    my $tideFormat = sub {
        my ($time1, $ht1, $htlt1) = @_;
        $time1    = main::time2str($tForm, $time1);
        $ht1      = main::convert_unit($ht1,'Tide');
        $htlt1    = $tdhl{$htlt1};
        return "${time1} ${ht1} ${htlt1}";
    };

    $tide_days_opt = ( $tide_days_opt ) ? $tide_days_opt  : 1        ;
    $tide_days_num = ( $tide_days_num ) ? $tide_days_num  : 7        ;
    $tide_date     = ( $tide_date     ) ? $tide_date      : 'monday' ;

    if ($tide_data and -e $tide_data ) {
        my ( $tidestr  ) ;
        {
        open (FILE, "<", "$tide_data") or die "$noFileMsg main data file $!";
            local $/ = undef;
            $tidestr = <FILE> ;
        close (FILE);
        }
        # my $ttime = "${hour}:${min}:${sec}" ;

        my ($td_range) = ($tidestr =~ m{The largest known tidal range at Navi Mumbai is:.*?range-spring-tide__secondary">\((.*?) feet}) ? main::convert_unit($1,'Tide') : ($tidestr =~ m{<div class="tide-range__items--height"><!--Range value--><b>(.*?)ft</b><span>} ? main::convert_unit($1,'Tide') : 'NA') ;
        # msgout($td_range);

        my ($td_loc) = ($tidestr =~ m{<title>Tide.*?for\s*(.*?)</title>})
        ? main::do_cleanup_lang( 2, \$1) : "Tide table:";

        $td_loc =~ s/[,]/ -/g;

        $td_loc .= ":\n MaxRange:$td_range\n";

        while ($tidestr =~ m{<div id="tide-table">(.*?)sun-moon not_in_print}g) {
            my $j = $1;
            my (%td);
            #####################
            # <td class="tide-state">Low Tide</td><td><b> 5:34 PM</b> <span class="tide-table__tide-data--secondary">(Wednesday 30 October)</span></td><td><b>-0.23 feet</b> <span class="tide-table__tide-data--secondary">(-0.07 m)</span></td></tr><tr>
            # <td class="tide-state">Low Tide</td><td><b> 6:46 AM</b> <span class="tide-table__tide-data--secondary">(Tuesday 12 November)</span></td><td class="two-units-length-value" data-units="Metric"><b class="two-units-length-value__primary">1.36 m</b> <span class="tide-table__tide-data--secondary two-units-length-value__secondary">(4.46 ft)</span></td></tr><tr>

                # msgout($j) ;

            if ($j =~ m{<h4 class="tide-table__date">.*?:\s*(.*?)\s*</h4>}) {
                # msgout($1);
                $td{day} = $1
            }
            my $cntn = 1;
            # while ($j =~ m{<td class="tide-state">(Low Tide|High Tide)</td><td><b>(.*?)</b>.*?secondary">.*?</span></td><td.*?"><b.*?">(.*?)</b.*?__secondary">\((.*?)\)</span}g) {
            while ($j =~ m{<td class="tide-state">(Low Tide|High Tide)</td><td><b>(.*?)</b>.*?>.*?</span></td><td.*?<b.*?>(.*?)</b.*?secondary">\((.*?)\)</span}g) {
            # while ($j =~ m{<td class="tide-state">(Low Tide|High Tide)</td><td><b>(.*?)</b>.*?</td><td><b>(.*?)</b>.*?secondary">\((.*?)\)</span>}g) {
                my ($tideht);
                if ( index($3, 'ft') != -1 or index($3, 'feet') != -1 ) {
                    ($tideht) = ($3 =~ m{(-?\d+(\.\d+)?)});
                }
                elsif ( index($4, 'ft') != -1 or index($4, 'feet') != -1 ) {
                    ($tideht) = ($4 =~ m{(-?\d+(\.\d+)?)});
                }
                # msgout($td{day},$cntn,$1) ;
                # msgout($td{day},$cntn,$2,$tideht,$1) if $1 and $2 and $tideht;
                $td{$cntn.'time'} = $2;
                $td{$cntn.'ht'}   = $tideht;
                $td{$cntn.'htlt'} = $1;
                $cntn++;
            }
            push(@tset, {%td}) if $td{day};
        }

        open (TFILE, '>', "$temppath/tides" ) or die "$$noFileMsg tides file $!";
        print TFILE $td_loc;
        my $ydayt;
        $yday += 0;
        for my $i ( 0 .. $#tset ) {
            my $cnt;
            my $cnt2 = 1;
            for my $role ( keys %{ $tset[$i] } ) {
                if ( $role eq 'day') {
                    # $ydayt = main::time2str( '%j',"$tset[$i]{$role} $year $ttime") if $i == 0;
                    $ydayt = main::time2str( '%j',"$tset[$i]{$role}") if $i == 0;
                    if ( $tide_days_opt == 1 ) {
                        $cnt = ( $ydayt == $yday ) ? 1 : undef
                    }
                    elsif ( $tide_days_opt == 2 ) {
                        $cnt = ( $ydayt <= $yday and $ydayt > ($yday - $tide_days_num) ) ?
                        1 : undef
                    }
                    elsif ( $tide_days_opt == 3 ) {
                        $cnt = ( $ydayt >= $yday and $ydayt < ($yday + $tide_days_num) ) ?
                        1 : undef
                    }
                    elsif ( $tide_days_opt == 4 ) { $cnt = 1 }
                    else { undef $cnt }
                    $ydayt += 1;
                }
                if ( $tide_days_opt == 5) {
                    if ( $tset[$i]{'day'} =~ /\b$tide_date/i ) {
                        print TFILE "$tset[$i]{day}\n" if $tset[$i]{$cnt2.'time'};
                        while ($tset[$i]{$cnt2.'time'}) {
                            my $prn = &$tideFormat($tset[$i]{$cnt2.'time'}, $tset[$i]{$cnt2.'ht'}, $tset[$i]{$cnt2.'htlt'});
                            print TFILE "$prn\n";
                            $cnt2++;
                        }
                    }
                }
                else {
                    if ($cnt) {
                        # print TFILE "$tset[$i]{day}\n" if $tset[$i]{$cnt2.'time'};
                        if ( $tset[$i]{$cnt2.'time'} ) {
                            my $dt1 = main::time2str($tide_date_format, "$tset[$i]{day}");
                            print TFILE "zzz $dt1\n";
                            # msgout($tForm);
                        }
                        while ($tset[$i]{$cnt2.'time'}) {
                            my $prn = &$tideFormat($tset[$i]{$cnt2.'time'}, $tset[$i]{$cnt2.'ht'}, $tset[$i]{$cnt2.'htlt'});
                            print TFILE "$prn\n";
                            $cnt2++;
                        }
                    }
                }
            }
        }
        close(TFILE);
    }

}  # end sub tides


1;
