
--[[
    Paramvir Likhari - conkywx 2017 - GPL3
--]]


local w = {}

-- local myPackage = package
-- myPackage.path = myPackage.path .. ";./lib/?.lua;"

local Global_Font_Size
local TORADIANS = 3.14159265358979323846/180
local tconcat   = table.concat
local tonum     = tonumber
local supper    = string.upper
local getlocal  = debug.getlocal

local lcairo_move_to                     = cairo_move_to
local lcairo_line_to                     = cairo_line_to
local lcairo_rel_line_to                 = cairo_rel_line_to
local lcairo_rotate                      = cairo_rotate
local lcairo_show_text                   = cairo_show_text
local lcairo_stroke                      = cairo_stroke
local lcairo_fill                        = cairo_fill
local lcairo_save                        = cairo_save
local lcairo_restore                     = cairo_restore
local lcairo_set_source_rgba             = cairo_set_source_rgba
local lcairo_set_source                  = cairo_set_source
local lcairo_rectangle                   = cairo_rectangle
local lcairo_close_path                  = cairo_close_path
local lcairo_set_line_width              = cairo_set_line_width
local lcairo_pattern_create_linear       = cairo_pattern_create_linear
local lcairo_pattern_add_color_stop_rgba = cairo_pattern_add_color_stop_rgba
local lcairo_pattern_destroy             = cairo_pattern_destroy

local function getLocalVars(var)
    local retVal
    local count = 1
    while true do
        local ln, lv = getlocal(2, count)
        if ln then
            if lv ~= '' and ln == var then retVal = lv end
        else
            break
        end
        count = 1 + count
    end
    return retVal
end

function w.vumeter(p)

    local FC = require("luafunc")
    local wxsplit     = FC.wxsplit
    local to_rgba     = FC.to_rgba
    local do_set_font = FC.set_font
    local make_txt    = FC.make_txt
    local getDatafile = FC.getDatafile

    local function set_font(p)
        if not Global_Font_Size then
            Global_Font_Size = do_set_font(p) or 12
        end
        do_set_font(p)
    end

    local extents = cairo_text_extents_t:create()
    tolua.takeownership(extents)

    local cr            = p.cr
    local no_data       = "Error :( - vumeter - No data input"
    local valid_opts    = "Error :( - vumeter - Valid -o options-M,H,U or V"
    local dataPath      = "Error :( - vumeter - Valid -b option vumeterdata.lua location not specified"

    local x             = p.lwx + 4.5   or 0
    local y             = p.lwy         or 0
    local dataFile      = p.b           or error(dataPath)
    local hdata         = p.d           or error(no_data)
    local maxuv         = p.x           or nil
    local vuType        = supper(p.o)   or error(valid_opts)
    local hide_numbers  = p.i           or 0
    local runit         = p.u
    local moonState     = p.m           or ""

    local sizeval = {}
    if p.s then
        sizeval = wxsplit(p.s,":")
    else
        if sizeval[1] == "" then sizeval[1] = 150 end
        if sizeval[2] == "" then sizeval[2] = 30  end
    end

    local maxscale = tonum(sizeval[1])   or 150
    local maxht    = tonum(sizeval[2])   or 30

    local hval1, labelTextAddon
    local vuOptions = {}
    ----- pull in tables from data file
    if dataFile then
        local VD = getDatafile(dataFile)
        vuOptions = VD.vuData
    end

    if vuOptions[vuType].unitToShow:match('%$%{') then
        local var1 = getLocalVars(vuOptions[vuType].unitToShow:match('${(.-)}'))
        vuOptions[vuType].unitToShow = vuOptions[vuType].unitToShow:gsub('${(.-)}', var1)
    end

    local vhstyle = p.v or vuOptions[vuType].vhstyle

------- cont
    -- print(hdata)
    if hdata ~= "NA" then
        if not tonum(hdata) then
            hval1 = (tonum(hdata:match('([%d%.]+)')) or 0)
        else
            hval1 = hdata
        end
        local textToShow
        if vuOptions[vuType].showOriginalValue then
            textToShow = p.d
        else
            textToShow = hval1
        end
        labelTextAddon = tconcat({" ", textToShow, vuOptions[vuType].unitToShow, vuOptions[vuType].sep2})
    else
        hval1 = 0
        labelTextAddon = " NA"
    end

    local wmax = maxscale-14
    hval = (hval1 / vuOptions[vuType].maxDivisor) * (wmax / 10)
    if hval >= wmax then hval = wmax end

    local tx,ty,ix,iy,bx,by,sx,sy,rh,rw,pat,hh,hw1,hw2,yt
    if vhstyle == "H" then
        rh=maxht; rw=maxscale
        pat = lcairo_pattern_create_linear(x+rw,0,x,0);
        hh=5; hw1=(rh-11); hw2=hw1+10; sx=x+5
        if not hval then hval=0 end
        tx,ty = sx + hval + hh, y + hw1
        ix,iy = sx + hval, y + hw2
        bx,by = sx + hval - hh, y + hw1
    elseif vhstyle == "V" then
        yt=y-1; rh=maxscale; rw=maxht
        pat = lcairo_pattern_create_linear(0,yt,0,yt+rh);
        hh=5; hw1=(rw-11); hw2=hw1+10; sy=y+maxscale-5
        if not hval then hval=0 end
        tx,ty = x + hw1, sy - hval + hh
        ix,iy = x + hw2, sy - hval
        bx,by = x + hw1, sy - hval - hh
    end
    lcairo_pattern_add_color_stop_rgba(pat, vuOptions[vuType].colourStop[1], to_rgba(vuOptions[vuType].startColour))
    lcairo_pattern_add_color_stop_rgba(pat, vuOptions[vuType].colourStop[2], to_rgba(vuOptions[vuType].midColour))
    lcairo_pattern_add_color_stop_rgba(pat, vuOptions[vuType].colourStop[3], to_rgba(vuOptions[vuType].endColour))
    lcairo_rectangle(cr,x,y,rw,rh)
    lcairo_set_source(cr, pat)
    lcairo_fill(cr)
    lcairo_pattern_destroy(pat)
    lcairo_set_source_rgba(cr, to_rgba(vuOptions[vuType].pointerColour)) -- pointer colour
    lcairo_move_to(cr,tx,ty)
    lcairo_line_to(cr,ix,iy)
    lcairo_line_to(cr,bx,by)
    lcairo_close_path(cr)
    if vhstyle == "H" then
        lcairo_rectangle(cr,x+5,y+rh,hval,-3)
    elseif vhstyle == "V" then
        lcairo_rectangle(cr,x+rw-3,y+rh-5,3,-hval)
    end
    lcairo_fill(cr)

    lcairo_save(cr)
    set_font({ cr, "Mono:8:bold" })
    local extents = cairo_text_extents_t:create()
    tolua.takeownership(extents)

    lcairo_set_source_rgba(cr,to_rgba(vuOptions[vuType].numberColour))  --- marker and number colour
    local inc1
    for i=1,11 do
        local lwid,incl,imarks = -3,nil,nil
        lcairo_set_line_width( cr, 1.5 )
        if vhstyle == "H" then
            imarks = (sx+wmax)-((i-1)*(wmax/10))
            lcairo_move_to(cr,imarks,y+rh)
            lcairo_rel_line_to(cr,0,lwid)
            if maxscale <= 100 then
                if i%2==0  then inc1=(11-i)
                else inc1=" "
                end
            else inc1=(11-i) end
            lcairo_save(cr)
            if hide_numbers ~= 1 then
                local mkTable = { cr = cr, ext=extents, text=inc1, px=imarks-1, py=y+hw2-3 }
                make_txt(mkTable)
            else
                lcairo_stroke(cr)
            end
        elseif vhstyle == "V" then
            imarks = (sy)-((i-1)*(wmax/10))
            lcairo_move_to(cr,x+rw,imarks)
            lcairo_rel_line_to(cr,lwid,0)
            if maxscale <= 100 then
                if i%2==0  then inc1=(i-1)
                else inc1=""
                end
            else inc1=(i-1) end
            lcairo_save(cr)
            if hide_numbers ~= 1 then
                local mkTable = { cr = cr, ext=extents, text=inc1, px=x+rw-10, py=imarks+3 }
                make_txt(mkTable)
            else
                lcairo_stroke(cr)
            end
        end
    end
    -- local outtext = nil
    local label = vuOptions[vuType].label .. labelTextAddon

    lcairo_save(cr)
    set_font({ cr, "Mono:11" })
    lcairo_set_source_rgba(cr,to_rgba(vuOptions[vuType].textColour)) -- label colour
    lcairo_save(cr)
    if vhstyle == "H" then
        lcairo_move_to(cr,x+3,y+12)
    elseif vhstyle == "V" then
        lcairo_move_to(cr,x+12,sy)
        lcairo_rotate(cr,TORADIANS*(-90))
    end
    lcairo_show_text(cr,label)
    lcairo_stroke(cr)
end

collectgarbage()
return w
