
--[[
    Paramvir Likhari - conkywx 2011 - 2016 - GPL3
    common library for use with conkywx lua implementation
--]]

local TORADIANS    = 3.14159265358979323846/180


local w = {true}

local lcollectgarbage = collectgarbage

local lcairo_set_line_width  = cairo_set_line_width
local lcairo_set_source_rgba = cairo_set_source_rgba
local lcairo_move_to         = cairo_move_to
local lcairo_line_to         = cairo_line_to
local lcairo_stroke          = cairo_stroke
local lcairo_fill            = cairo_fill
local lcairo_arc             = cairo_arc
local lcairo_save            = cairo_save
local lcairo_restore         = cairo_restore

-- local myPackage = package
-- myPackage.path = myPackage.path .. ";./lib/?.lua;"

function w.wxgraph(p)

    local FC = require("luafunc")
    local wxsplit = FC.wxsplit
    local to_rgba = FC.to_rgba

    local cr        = p.cr
    local px, py    = p.lwx, p.lwy
    local sccolour  = p.c or "0x00ff00:1"
    local mcolour   = wxsplit(sccolour,":")
    local t1        = wxsplit(p.d,",")
    local wxgfactor = p.s or 1
    local kind      = p.k or 2

    local th_fact
    if wxgfactor == 1 then
        th_fact = 2
    else
        th_fact = wxgfactor * 1.4
    end
    local width = 3.7 * wxgfactor

    lcairo_set_line_width(cr, th_fact)
    lcairo_set_source_rgba(cr, to_rgba(mcolour))
    for i = 1, #t1-1 do
        t1[i] = t1[i] * wxgfactor
        if kind == 1 then
            lcairo_move_to(cr, px + width * i, py - t1[i])
            lcairo_line_to(cr, px + width * (i + 0.65), py - t1[i])
            lcairo_stroke(cr)
        else
            lcairo_arc(cr, px + width * (i + 0.5), py - t1[i], width * 0.27, TORADIANS, 0)
            lcairo_fill(cr)
        end
    end
end

lcollectgarbage()

return w
