#!/usr/bin/lua

local lfloor   = math.floor
local tconcat  = table.concat
local tonum    = tonumber
local lremove  = os.remove
local lexecute = os.execute
local lmatch   = string.match
-- local lgetenv  = os.getenv

local lcollectgarbage = collectgarbage

--- this is required as it is not called from conkywx.lua
--- this is a stand alone script - maybe do this in perl
function ScriptPath()
   local str = debug.getinfo(2, "S").source:sub(2)
   return lmatch(str,"(.*/)")
end
package.path = package.path .. ";" .. ScriptPath() .. "?.lua;"

local FC = require("luafunc")

local wxsplit    = FC.wxsplit
local ExecInfo   = FC.ExecInfo
local FileStat   = FC.FileStat
local FileExists = FC.FileExists
local DirExists  = FC.DirExists
local msgout     = FC.msgout

local werdone          -- required for mplayer stuff
local shfl_loop_label  -- required for mplayer stuff
local loop_times       -- required for mplayer stuff
local lr = lr or 0     -- required for mplayer stuff
local ctrack
local tpt
local total_lines
local curr_aud
local mdata
local audnow = {}

-- local wxtmpDir = '/tmp/conkywx_' .. lgetenv("USER") ..

-- End Constants --------------------------------------------------
local player
if ExecInfo({ cmd = 'pidof mplayer' }) then player = true else player = false end
local wxcount = 1
while player do
	if DirExists('/tmp/wxmptmp/') then
		local m3utmp  = '/tmp/wxmptmp/tmpflist.m3u'
		local RndmIdx = '/tmp/wxmptmp/random'
		local mpfifo  = '/tmp/wxmptmp/mpfifo'

		local function getLine(t)
			local lcount = t.lcount
			lcount = (lcount * 2) + 1      -- get total lines in the file
			local x1                       -- get number for tail
			if t.line < (lcount/2) then x1=tconcat({'+',t.line}) else x1=(lcount-t.line)+1 end
			return ExecInfo({ cmd =
				tconcat({ 'tail -n ',x1,' ',m3utmp,' | head -n 1'})
			})
		end

		local function getidx(t)
			return ExecInfo({
				cmd = tconcat({'tail -n +',t.num,' ',RndmIdx,' | head -n 1'})
			})
		end

		wxcount = wxcount + 1

		ExecInfo({
			cmd = 'echo "pausing_keep_force get_property pause" > /tmp/wxmptmp/mpfifo'
		})
		audnow.astat = ExecInfo({ rfile = '/tmp/wxmptmp/ANS_pause' })

		if not audnow.astat or audnow.astat == '' then
			audnow.astat = 'no'
		end

		if audnow.astat and audnow.astat == 'no' then
			ExecInfo({
				cmd = 'echo "pausing_keep_force get_property time_pos" > /tmp/wxmptmp/mpfifo'
			})
		end

		audnow.c_sec = ExecInfo({ rfile = '/tmp/wxmptmp/ANS_time_pos' })
		audnow.c_sec = tonum(audnow.c_sec) or 0

		if not audnow.t_fnm or lmatch(audnow.t_fnm,'echo') then
			audnow.t_fnm = 'Buffering...'
		end

		local ct_info, trackno
		if not trackno or FileExists('/tmp/wxmptmp/ct_info') then
			ct_info = ExecInfo({ rfile = '/tmp/wxmptmp/ct_info' })
			if ct_info then
				local ctin   = {}
				ctin         = wxsplit(ct_info,':::')
				audnow.p_pos = 1
				audnow.t_fnm = ctin[1]        or 'Buffering...'
				audnow.c_ttl = ctin[2]        or 'Buffering...'
				audnow.c_min = (tonum(ctin[3]) or 1)
				audnow.c_kbt = (tonum(ctin[4]) or 1)
				audnow.c_khz = ctin[5]
				audnow.c_chl = (tonum(ctin[6]) or 1)
				tpt          = (tonum(ctin[7]) or 1)
				audnow.p_ttl = (tonum(ctin[8]) or 1)
			end
		else
			lremove('/tmp/wxmptmp/tpt')
		end

		if audnow.t_fnm then
			local goto_trk, curr_trk, prev_trk, next_trk

			trackno = ExecInfo({ rfile = '/tmp/wxmptmp/trackno' })
			trackno = tonum(trackno) or 1

			local sop,Ftpt
			if FileExists('/tmp/wxmptmp/sop') then sop  = true else sop  = false end
			if FileExists('/tmp/wxmptmp/tpt') then Ftpt = true else Ftpt = false end

			if trackno ~= ctrack or sop or not Ftpt then
				ctrack = trackno

				local lFstat,stotals
				if FileStat({ ifile=m3utmp, ofile='/tmp/wxmptmp/fstat' }) then lFstat = true
				else lFstat = false end

				if  not Ftpt or not lFstat then

					-- add the time of each track and get total time and line count
					stotals = ExecInfo({
						cmd = tconcat({"awk -F'[:,]' '{SUM += $2} END { print SUM,NR }' ",m3utmp})
					})

					local sda = wxsplit(stotals,' ')
					-- msgout(lmatch(stotals,'([%d]+)%s+([%d]+)'))
					tpt = sda[1]           or 0
					total_lines = sda[2]   or 0
					-- total_lines = total tracks excluding comments
					total_lines = lfloor((tonum(lmatch(total_lines,"(%d+)")) - 1) / 2)

					stotals = tconcat({tpt,'::',total_lines})
					ExecInfo({ wfile = '/tmp/wxmptmp/tpt', wtext = stotals })
				elseif not tpt or not total_lines then
					stotals = ExecInfo({ rfile = '/tmp/wxmptmp/tpt' })
					local sda = wxsplit(stotals,'::')
					tpt = sda[1]; total_lines = sda[2]
				end

				local cln = getLine({ line =  trackno * 2     , lcount = total_lines })
				local rln = getLine({ line = (trackno * 2) + 1, lcount = total_lines })

				if not FileExists(rln) then
					ExecInfo({ wfile = '/tmp/wxmptmp/tolua', wtext = 'next'})
					-- lexecute('echo "next" > /tmp/wxmptmp/tolua')
					werdone = nil
					ctrack = nil
				else
					local ti,kh,ch,kb,tit = lmatch(cln,'^#EXTINF:(.-),(.-),(.-),(.-),(.-)$')
					-- ct_infor format = file name, title, track time, kbps, Hz, channels, total playlist time, total tracks
					local ct_info = tconcat({
						lmatch(rln,"([^/]+)$"),':::',tit,':::',ti,':::',
						(tonum(kb) or 1)*1000,':::',kh,':::',ch,':::',tpt,':::',total_lines,
					})
					ExecInfo({ wfile = '/tmp/wxmptmp/ct_info', wtext = ct_info })
					-- lexecute('echo \"'.. ct_info .. '\"  > /tmp/wxmptmp/ct_info')
				end
			end

			ct_info = ExecInfo({ rfile = '/tmp/wxmptmp/ct_info' })
			if ct_info then
				local ctin   = {}
				ctin         = wxsplit(ct_info,':::')
				audnow.p_pos = trackno
				audnow.t_fnm = ctin[1]        or 'Buffering...'
				audnow.c_ttl = ctin[2]        or 'Buffering...'
				audnow.c_min = (tonum(ctin[3]) or 1)
				audnow.c_kbt = (tonum(ctin[4]) or 1)
				audnow.c_khz = ctin[5]
				audnow.c_chl = (tonum(ctin[6]) or 1)
				tpt          = (tonum(ctin[7]) or 1)
				audnow.p_ttl = (tonum(ctin[8]) or 1)
			end

			tpt = tpt or 0
			local tptHours = tpt / 3600
			if tptHours > 99 then tptHours = 99 end

			if audnow.p_pos and audnow.p_pos > 1 then
				prev_trk = audnow.p_pos - 1
			else
				prev_trk = audnow.p_ttl
			end
			if audnow.p_pos < audnow.p_ttl then
				next_trk = audnow.p_pos + 1
			else
				next_trk = 1
			end
			-- local updateI = conky_info.update_interval
			local updateI = 1
			local lloop = ExecInfo({ rfile = '/tmp/wxmptmp/loop' })
			if lloop then
				if lmatch(lloop,'loop') then
					loop_times = tonum(lmatch(lloop,"(%-?%d+)"))
				end
				if loop_times == 0 then
					loop_times = 99
				elseif loop_times == -1 then
					loop_times = nil; lr = 0
					lremove('/tmp/wxmptmp/loop')
					lremove('/tmp/wxmptmp/lcnt')
				end
			else
				loop_times = nil
			end

			local shuffling,ctrk
			if FileExists('/tmp/wxmptmp/shuffle') then
				shuffling = true
				ctrk = ExecInfo({ rfile = '/tmp/wxmptmp/ctrk' })
			end

			local idata = ExecInfo({ rfile = '/tmp/wxmptmp/tolua' })
			lremove('/tmp/wxmptmp/tolua')
			if idata and not shuffling then
				loop_times = nil; lr = 0; shfl_loop_label = nil
				lremove('/tmp/wxmptmp/loop')
				lremove('/tmp/wxmptmp/lcnt')
				if lmatch(idata,'jump') then
					goto_trk = lmatch(idata,"(%d+)")
					if tonum(goto_trk) > audnow.p_ttl then goto_trk = 1
					elseif tonum(goto_trk) < 1 then goto_trk = 1
					end
				elseif lmatch(idata,'next') then
					goto_trk = next_trk
				elseif lmatch(idata,'prev') then
					goto_trk = prev_trk
				end
			elseif (audnow.c_min - audnow.c_sec) < (updateI+1) or
				( idata and shuffling ) then
				audnow.c_sec = 1
				if loop_times and not werdone then
					if lr < loop_times then
						lr = lr + 1
						goto_trk = audnow.p_pos
					else
						loop_times = nil; lr = 0
						lremove('/tmp/wxmptmp/loop')
						lremove('/tmp/wxmptmp/lcnt')
					end
				elseif shuffling and not werdone then
					if audnow.p_ttl <= 2 then
						lremove('/tmp/wxmptmp/shuffle')
					else
						local ctrk2 = {}
						if ctrk then
							ctrk2 = wxsplit(ctrk,':')
							if tonum(ctrk2[2]) ~= audnow.p_ttl then
								lremove(RndmIdx)
								ExecInfo({
									wfile = '/tmp/wxmptmp/ctrk', wtext = tconcat({1,':',audnow.p_ttl})
								})
							end
						end
						if FileExists(RndmIdx) then
							if ctrk then
								local cpos = tonum(ctrk2[1])
								local nval, pval, sval
								if cpos < audnow.p_ttl then nval=cpos+1 else nval = 1 end
								if cpos > 1 then pval=cpos-1 else pval = audnow.p_ttl end
								if idata then
									if lmatch(idata,'jump') then
										goto_trk = lmatch(idata,"(%d+)")
										if tonum(goto_trk) > audnow.p_ttl then goto_trk = 1
										elseif tonum(goto_trk) < 1 then goto_trk = 1
										end
										sval     = goto_trk
									elseif lmatch(idata,'next') then
										goto_trk = getidx({num=nval}); sval = nval
									elseif lmatch(idata,'prev') then
										goto_trk = getidx({num=pval}); sval = pval
									end
								else
									goto_trk = getidx({num=nval})
									sval     = nval
								end
								ExecInfo({
									wfile = '/tmp/wxmptmp/ctrk', wtext = tconcat({sval,':',audnow.p_ttl})
								})
							else
								goto_trk = getidx({ num = 1 })
								ExecInfo({
									wfile = '/tmp/wxmptmp/ctrk', wtext = tconcat({1,':',audnow.p_ttl})
								})
							end
						else
							ExecInfo({
								cmd = tconcat({'seq 1 1 ',audnow.p_ttl,' | shuf -o ',RndmIdx})
							})
							goto_trk = getidx({ num = 1 })
						end
					end
				else
					goto_trk = next_trk
				end
			end

			if loop_times then
				shfl_loop_label = tconcat({'Loop ',lr,'/',loop_times})
				if lr ~= 0 then
					ExecInfo({ wfile = '/tmp/wxmptmp/lcnt', wtext = lr })
				end
				local lcnt = ExecInfo({ rfile = '/tmp/wxmptmp/lcnt' })
				if lcnt then
					lr = tonum(lmatch(lcnt,"(%d+)"))
				else
					ExecInfo({ wfile = '/tmp/wxmptmp/lcnt', wtext = lr })
				end
			elseif shuffling == true then
				shfl_loop_label = ' Shfl'
			else
				shfl_loop_label = ''
			end

			local trk_play
			if goto_trk then
				local rt = (tonum(goto_trk) * 2 ) + 1
				local trk01 = getLine({line = rt,lcount = audnow.p_ttl})
				trk_play = trk01:gsub("%'","\\'")
			end

			if trk_play and not werdone and not sop then
				werdone = 1
				lremove('/tmp/wxmptmp/ANS_time_pos')
				ExecInfo({ cmd = 'echo "pause" > /tmp/wxmptmp/mpfifo' })
				ExecInfo({cmd = tconcat({ 'echo \"loadfile \'', trk_play,'\'\" > /tmp/wxmptmp/mpfifo' })})
				ExecInfo({ wfile = '/tmp/wxmptmp/trackno', wtext = goto_trk })
				audnow.c_sec = 0
				audnow.progress = 0
			elseif audnow.c_sec > 1 then
				werdone = nil
				lremove('/tmp/wxmptmp/sop')
			end
			-- if werdone ~= nil or goto_trk ~= nil then print(werdone,goto_trk,CurrTrackPerc) end
		end
	else
		break
	end
	lexecute('sleep 0.5')

	lcollectgarbage()
end

