#!/bin/bash
#---------------------------------------------
#   xdg-terminal
#
#   Utility script to open the registered terminal emulator
#
#   Refer to the usage() function below for usage.
#
#   Copyright 2009-2010, Fathi Boudra <fabo@freedesktop.org>
#   Copyright 2009-2010, Rex Dieter <rdieter@fedoraproject.org>
#   Copyright 2006, Kevin Krammer <kevin.krammer@gmx.at>
#   This modified for conkywx
#   LICENSE:
#
#---------------------------------------------
# debug='true'
# This defines the output of set -x debugging xtrace
if [[ $debug ]]; then
	rm -rf '/tmp/xdg-debug'
	export PS4='+ (${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
	exec 4>>'/tmp/xdg-debug'
	BASH_XTRACEFD=4
	set -x
fi

bpath2="$( dirname "$0" )"
mypath="$( cd "$bpath2" && pwd )"


source "${mypath}"/xdg-utils-common.sh


DefTerm=
command=( "$@" )

detectDE

if [ x"$DE" = x"" ]; then
	DE=generic
fi

case "$DE" in
	kde) 	    DefTerm=konsole                ;;
	gnome)      DefTerm=gnome-terminal         ;;
	gnome3)     DefTerm=gnome-terminal         ;;
	cinnamon)   DefTerm=gnome-terminal         ;;
	mate)       DefTerm=mate-terminal          ;;
	xfce)       DefTerm=xfce4-terminal         ;;
	lxde)       DefTerm=lxde-terminal          ;;
	generic)    DefTerm=xterm                  ;;
	*)          DefTermErr='-1'                ;;
esac

if [[ $DefTerm ]]; then
	if [[ "${command[*]}" ]]; then
		$DefTerm "${command[@]}"
	else
		echo $DefTerm
	fi
elif [[ $DefTermErr ]]; then
	echo $DefTermErr
fi

if [[ $debug ]]; then set +x ; fi



