#!/bin/bash

# set -x

cmdopt=$1
cmdopt=${cmdopt:0:3}
cmdopt=${cmdopt,,}
# printf "\n%b\n" "commandline opt=${cmdopt}" >&2
# if [[ $cmdopt == "dev" ]]; then
#   development=1; export development
# fi

case $cmdopt in
"dev")  development=1; export development ;;
"fup")  fupdate=1; export fupdate ;;
esac

# -----------------------------------------------------------------------
# stop existing conky processes
# -----------------------------------------------------------------------
if [[ $(pidof conky) ]] ; then killall -9 conky; fi

if [[ -s /usr/share/conkywx/conkywx.sh ]]; then
    conkywxVersion=$(/usr/share/conkywx/conkywx.sh -v)
    conkywxVersion="${conkywxVersion//[.]/}"
    WX_DIR="${HOME}/.config/conkywx/examples${conkywxVersion}"

    if [[ ! -d "${WX_DIR}" ]]; then
        mkdir -p "${WX_DIR}"
        if [[ -d "${WX_DIR}" ]]; then
            cd "${WX_DIR}"
            cp -p /usr/share/conkywx/examples/* .
            cp -p /usr/share/conkywx/conky-restart.sh .

            # sed -i 's`\s*WX_DIR=.*`WX_DIR=\"\'"${WX_DIR}"'\"\ncd /usr/share/conkywx`' conky-restart.sh

            sed -i 's#./lib/conkywx.lua#/usr/share/conkywx/lib/conkywx.lua#' *rc*
            sed -i 's#./conkywx.sh#/usr/share/conkywx/conkywx.sh#' *rc*
            sed -i 's#./examples/#'"${WX_DIR}"'/#' *rc*
        fi
    fi

    cd "/usr/share/conkywx"

    "${WX_DIR}/conky-restart.sh"
else
    "./conky-restart.sh"
fi

exit 0


